unit z80_dd;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses z80,z80_dd_cb,main_engine;

const z80t_dd:array[0..255] of byte=(
      //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
        4, 4, 4, 4, 4, 4, 4, 4, 4,15, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4,15, 4, 4, 4, 4, 4, 4,
 4,14,20,10, 9, 9,11, 4, 4,15,20,10, 9, 9,11, 4,
 4, 4, 4, 4,23,23,19, 4, 4,15, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 9, 9,19, 4, 4, 4, 4, 4, 9, 9,19, 4,
 4, 4, 4, 4, 9, 9,19, 4, 4, 4, 4, 4, 9, 9,19, 4,
 9, 9, 9, 9, 9, 9,19, 9, 9, 9, 9, 9, 9, 9,19, 9,
19,19,19,19,19,19, 4,19, 4, 4, 4, 4, 9, 9,19, 4,
 4, 4, 4, 4, 9, 9,19, 4, 4, 4, 4, 4, 9, 9,19, 4,
 4, 4, 4, 4, 9, 9,19, 4, 4, 4, 4, 4, 9, 9,19, 4,
 4, 4, 4, 4, 9, 9,19, 4, 4, 4, 4, 4, 9, 9,19, 4,
 4, 4, 4, 4, 9, 9,19, 4, 4, 4, 4, 4, 9, 9,19, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
 4,14, 4,23, 4,15, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4,10, 4, 4, 4, 4, 4, 4); //F0

function exec_dd_fd(r:preg_z80;ll:llam_z80;tipo:boolean):byte;

implementation
function exec_dd_fd(r:preg_z80;ll:llam_z80;tipo:boolean):byte;
var
 instruccion,temp:byte;
 temp2:word;
 registro:pparejas;
 posicion:parejas;
 estados_dd_cb:byte;
begin
if tipo then registro:=@r.ix else registro:=@r.iy;
temp2:=registro.w;
estados_dd_cb:=0;
r.opcode:=true;
instruccion:=ll.getbyte(r.pc);
r.opcode:=false;
r.pc:=r.pc+1;
r.r:=((r.r+1) and $7f) or (r.r and $80);
case instruccion of
        $09:add_16(r,registro,r.bc.w); {add IX,BC}
        $19:add_16(r,registro,r.de.w); {add IX,DE}
        $21:begin {ld IX,nn}
                registro.h:=ll.getbyte(r.pc+1);
                registro.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
            end;
        $22:begin {ld (nn),IX}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
                ll.putbyte(posicion.w,registro.l);
                ll.putbyte(posicion.w+1,registro.h);
            end;
        $23:registro.w:=registro.w+1; {inc IX}
        $24:begin  {inc IXh}
                temp:=registro.h;
                inc_8(r,@temp);
                registro.h:=temp;
            end;
        $25:begin {dec IXh}
                temp:=registro^.h;
                dec_8(r,@temp);
                registro^.h:=temp;
            end;
        $26:begin  {ld IXh,n}
                registro^.h:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $29:add_16(r,registro,registro^.w); {add IX,IX}
        $2a:begin {ld (IX,(nn)}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
                registro^.l:=ll.getbyte(posicion.w);
                registro^.h:=ll.getbyte(posicion.w+1);
            end;
        $2b:registro^.w:=registro^.w-1; {dec IX}
        $2c:begin  {inc IXl}
                temp:=registro^.l;
                inc_8(r,@temp);
                registro^.l:=temp;
            end;
        $2d:begin  {dec IXl}
                temp:=registro^.l;
                dec_8(r,@temp);
                registro^.l:=temp;
            end;
        $2e:begin  {ld IXl,n}
                registro^.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $34:begin {inc (IX+d)} //debo tener en cuenta que temp2=registro.w
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                inc_8(r,@temp);
                ll.putbyte(temp2,temp);
            end;
        $35:begin {dec (IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                dec_8(r,@temp);
                ll.putbyte(temp2,temp);
           end;
        $36:begin {ld (IX+d),n}
                temp:=ll.getbyte(r.pc);
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(r.pc+1);
                r.pc:=r.pc+2;
                ll.putbyte(temp2,temp);
            end;
        $39:add_16(r,registro,r.sp); {add IX,SP}
        $44:r.bc.h:=registro^.h; {ld B,IXh}
        $45:r.bc.h:=registro^.l; {ld B,IXl}
        $46:begin {ld B,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.bc.h:=ll.getbyte(temp2);
            end;
        $4c:r.bc.l:=registro^.h; {ld C,IXh}
        $4d:r.bc.l:=registro^.l; {ld C,IXl}
        $4e:begin {ld C,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.bc.l:=ll.getbyte(temp2);
            end;
        $54:r.de.h:=registro^.h;  {ld D,IXh}
        $55:r.de.h:=registro^.l;  {ld D,IXl}
        $56:begin {ld D,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.de.h:=ll.getbyte(temp2);
            end;
        $5c:r.de.l:=registro^.h;  {ld E,IXh}
        $5d:r.de.l:=registro^.l;  {ld E,IXh}
        $5e:begin {ld E,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.de.l:=ll.getbyte(temp2);
            end;
        $60:registro^.h:=r.bc.h;  {ld IXh,B}
        $61:registro^.h:=r.bc.l;  {ld IXh,C}
        $62:registro^.h:=r.de.h;  {ld IXh,D}
        $63:registro^.h:=r.de.l;  {ld IXh,E}
        $64:;
        $65:registro^.h:=registro^.l;  {ld IXh,IXl}
        $66:begin {ld H,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.hl.h:=ll.getbyte(temp2);
            end;
        $67:registro^.h:=r.a;  {ld IXh,A}
        $68:registro^.l:=r.bc.h;  {ld IXl,B}
        $69:registro^.l:=r.bc.l;  {ld IXl,C}
        $6a:registro^.l:=r.de.h;  {ld IXl,D}
        $6b:registro^.l:=r.de.l;  {ld IXl,E}
        $6c:registro^.l:=registro^.h;  {ld IXl,IXh}
        $6d:; {ld IXl,IXl}
        $6e:begin {ld L,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.hl.l:=ll.getbyte(temp2);
            end;
        $6f:registro^.l:=r.a; {ld IXl,A}
        $70:begin {ld (IX+d),B}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.bc.h);
            end;
        $71:begin {ld (IX+d),C}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.bc.l);
            end;
        $72:begin {ld (IX+d),D}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.de.h);
            end;
        $73:begin {ld (IX+d),E}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.de.l);
            end;
        $74:begin {ld (IX+d),H}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.hl.h);
            end;
        $75:begin {ld (IX+d),L}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.hl.l);
            end;
        $77:begin {ld (IX+d),A}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                ll.putbyte(temp2,r.a);
            end;
        $7c:r.a:=registro^.h;  {ld A,IXh}
        $7d:r.a:=registro^.l; {ld A,IXl}
        $7e:begin {ld A,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                r.a:=ll.getbyte(temp2);
            end;
        $84:add_8(r,registro^.h);  {add A,IXh}
        $85:add_8(r,registro^.l);  {add A,IXl}
        $86:begin {add A,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                add_8(r,temp);
            end;
        $8c:adc_8(r,registro^.h);  {adc A,IXh}
        $8d:adc_8(r,registro^.l);  {adc A,IXl}
        $8e:begin {adc A,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                adc_8(r,temp);
        end;
        $94:sub_8(r,registro^.h); {sub IXh}
        $95:sub_8(r,registro^.l); {sub IXh}
        $96:begin {sub (IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                sub_8(r,temp);
        end;
        $9c:sbc_8(r,registro^.h); {sbc IXh}
        $9d:sbc_8(r,registro^.l); {sbc IXl}
        $9e:begin {sbc (IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                sbc_8(r,temp);
        end;
        $a4:and_a(r,registro^.h); {and IXh}
        $a5:and_a(r,registro^.l); {and IXl}
        $a6:begin {and A,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                and_a(r,temp);
        end;
        $ac:xor_a(r,registro^.h); {xor IXh}
        $ad:xor_a(r,registro^.l); {xor IXl}
        $ae:begin {xor A,(IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                xor_a(r,temp);
              end;
        $b4:or_a(r,registro^.h);  {or IXh}
        $b5:or_a(r,registro^.l);  {or IXl}
        $b6:begin  {or (IX+d)}
                 temp:=ll.getbyte(r.pc);
                 r.pc:=r.pc+1;
                 temp2:=temp2+shortint(temp);
                 temp:=ll.getbyte(temp2);
                 or_a(r,temp);
             end;
        $bc:cp_a(r,registro^.h); {cp IXh}
        $bd:cp_a(r,registro^.l); {cp IXl}
        $be:begin {cp (IX+d)}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                temp2:=temp2+shortint(temp);
                temp:=ll.getbyte(temp2);
                cp_a(r,temp);
        end;
        $cb:estados_dd_cb:=exec_dd_cb(r,ll,tipo);
        $e1:pop_sp(@r.sp,ll,registro);  {pop IX}
        $e3:begin   {ex (SP),IX}
                pop_sp(@r.sp,ll,@posicion);
                push_sp(@r.sp,ll,registro);
                registro^.w:=posicion.w;
             end;
        $e5:push_sp(@r.sp,ll,registro);  {push IX}
        $e9:r.pc:=registro^.w; {jp IX}
        $f9:r.sp:=registro^.w; {ld SP,IX}
        else begin
          //MessageDlg('Instruccion desconocida DD. PC= '+inttostr(r.pc.w), mtInformation,[mbOk], 0);
          r.pc:=r.pc-1;
          r.r:=(r.r-1) and $7f;
        end;
end;
exec_dd_fd:=z80t_dd[instruccion]+estados_dd_cb;
end;

end.
