unit z80_cb_sp;

interface
uses z80,z80_sp,spectrum_misc,z80_cb;

procedure exec_cb_sp(r:preg_z80;ll:llam_z80);

implementation
procedure exec_cb_sp(r:preg_z80;ll:llam_z80);
var
        instruccion,temp:byte;
begin
spec_retraso.retraso(r.pc);inc(r.contador,4);
instruccion:=ll.getbyte(r.pc);
inc(r.pc);
r.r:=((r.r+1) and $7f) or (r.r and $80);
case instruccion of
        $00:rlc_8(r,@r.bc.h); {rlc B >8t<}
        $01:rlc_8(r,@r.bc.l); {rlc C >8t<}
        $02:rlc_8(r,@r.de.h); {rlc D >8t<}
        $03:rlc_8(r,@r.de.l); {rlc E >8t<}
        $04:rlc_8(r,@r.hl.h); {rlc H >8t<}
        $05:rlc_8(r,@r.hl.l); {rlc L >8t<}
        $06:begin {rlc (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                rlc_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $07:rlc_8(r,@r.a); {rlc A >8t<}
        $08:rrc_8(r,@r.bc.h); {rlc B >8t<}
        $09:rrc_8(r,@r.bc.l); {rlc C >8t<}
        $0a:rrc_8(r,@r.de.h); {rlc D >8t<}
        $0b:rrc_8(r,@r.de.l); {rlc E >8t<}
        $0c:rrc_8(r,@r.hl.h); {rlc H >8t<}
        $0d:rrc_8(r,@r.hl.l); {rlc L >8t<}
        $0e:begin {rlc (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                rrc_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $0f:rrc_8(r,@r.a); {rlc A >8t<}
        $10:rl_8(r,@r.bc.h); {rl B >8t<}
        $11:rl_8(r,@r.bc.l); {rl C >8t<}
        $12:rl_8(r,@r.de.h); {rl D >8t<}
        $13:rl_8(r,@r.de.l); {rl E >8t<}
        $14:rl_8(r,@r.hl.h); {rl H >8t<}
        $15:rl_8(r,@r.hl.l); {rl L >8t<}
        $16:begin {rl (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                rl_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $17:rl_8(r,@r.a); {rl A >8t<}
        $18:rr_8(r,@r.bc.h); {rr B >8t<}
        $19:rr_8(r,@r.bc.l); {rr C >8t<}
        $1a:rr_8(r,@r.de.h); {rr D >8t<}
        $1b:rr_8(r,@r.de.l); {rr E >8t<}
        $1c:rr_8(r,@r.hl.h); {rr H >8t<}
        $1d:rr_8(r,@r.hl.l); {rr L >8t<}
        $1e:begin {rr (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                rr_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $1f:rr_8(r,@r.a); {rr A >8t<}
        $20:sla_8(r,@r.bc.h); {sla B >8t<}
        $21:sla_8(r,@r.bc.l); {sla C >8t<}
        $22:sla_8(r,@r.de.h); {sla D >8t<}
        $23:sla_8(r,@r.de.l); {sla E >8t<}
        $24:sla_8(r,@r.hl.h); {sla H >8t<}
        $25:sla_8(r,@r.hl.l); {sla L >8t<}
        $26:begin {sla (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                sla_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $27:sla_8(r,@r.a); {sla A >8t<}
        $28:sra_8(r,@r.bc.h); {sra B >8t<}
        $29:sra_8(r,@r.bc.l); {sra C >8t<}
        $2a:sra_8(r,@r.de.h); {sra D >8t<}
        $2b:sra_8(r,@r.de.l); {sra E >8t<}
        $2c:sra_8(r,@r.hl.h); {sra H >8t<}
        $2d:sra_8(r,@r.hl.l); {sra L >8t<}
        $2e:begin {sra (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                sra_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $2f:sra_8(r,@r.a); {sra A >8t<}
        $30:sll_8(r,@r.bc.h); {sll B >8t<}
        $31:sll_8(r,@r.bc.l); {sll C >8t<}
        $32:sll_8(r,@r.de.h); {sll D >8t<}
        $33:sll_8(r,@r.de.l); {sll E >8t<}
        $34:sll_8(r,@r.hl.h); {sll H >8t<}
        $35:sll_8(r,@r.hl.l); {sll L >8t<}
        $36:begin  {sll (HL)}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                sll_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $37:sll_8(r,@r.a); {sll a >8t<}
        $38:srl_8(r,@r.bc.h); {srl B >8t<}
        $39:srl_8(r,@r.bc.l); {srl C >8t<}
        $3a:srl_8(r,@r.de.h); {srl D >8t<}
        $3b:srl_8(r,@r.de.l); {srl E >8t<}
        $3c:srl_8(r,@r.hl.h); {srl H >8t<}
        $3d:srl_8(r,@r.hl.l); {srl L >8t<}
        $3e:begin  {srl (HL) >15t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                srl_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $3f:srl_8(r,@r.a); {srl a >8t<}
        $40:bit_8(0,r.bc.h,@r.f); {bit 0,B >8t<}
        $41:bit_8(0,r.bc.l,@r.f); {bit 0,C >8t<}
        $42:bit_8(0,r.de.h,@r.f); {bit 0,D >8t<}
        $43:bit_8(0,r.de.l,@r.f); {bit 0,E >8t<}
        $44:bit_8(0,r.hl.h,@r.f); {bit 0,H >8t<}
        $45:bit_8(0,r.hl.l,@r.f); {bit 0,L >8t<}
        $46:begin  {bit 0,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(0,temp,@r.f)
            end;
        $47:bit_8(0,r.a,@r.f); {bit 0,A >8t<}
        $48:bit_8(1,r.bc.h,@r.f); {bit 1,B >8t<}
        $49:bit_8(1,r.bc.l,@r.f); {bit 1,C >8t<}
        $4a:bit_8(1,r.de.h,@r.f); {bit 1,D >8t<}
        $4b:bit_8(1,r.de.l,@r.f); {bit 1,E >8t<}
        $4c:bit_8(1,r.hl.h,@r.f); {bit 1,H >8t<}
        $4d:bit_8(1,r.hl.l,@r.f); {bit 1,L >8t<}
        $4e:begin  {bit 1,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(1,temp,@r.f)
            end;
        $4f:bit_8(1,r.a,@r.f); {bit 1,A >8t<}
        $50:bit_8(2,r.bc.h,@r.f); {bit 2,B >8t<}
        $51:bit_8(2,r.bc.l,@r.f); {bit 2,C >8t<}
        $52:bit_8(2,r.de.h,@r.f); {bit 2,D >8t<}
        $53:bit_8(2,r.de.l,@r.f);  {bit 2,E >8t<}
        $54:bit_8(2,r.hl.h,@r.f);  {bit 2,H >8t<}
        $55:bit_8(2,r.hl.l,@r.f);  {bit 2,L >8t<}
        $56:begin  {bit 2,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(2,temp,@r.f)
            end;
        $57:bit_8(2,r.a,@r.f); {bit 2,A >8t<}
        $58:bit_8(3,r.bc.h,@r.f); {bit 3,B >8t<}
        $59:bit_8(3,r.bc.l,@r.f); {bit 3,C >8t<}
        $5a:bit_8(3,r.de.h,@r.f); {bit 3,D >8t<}
        $5b:bit_8(3,r.de.l,@r.f); {bit 3,E >8t<}
        $5c:bit_8(3,r.hl.h,@r.f); {bit 3,H >8t<}
        $5d:bit_8(3,r.hl.l,@r.f); {bit 3,L >8t<}
        $5e:begin  {bit 3,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(3,temp,@r.f)
            end;
        $5f:bit_8(3,r.a,@r.f); {bit 3,A >8t<}
        $60:bit_8(4,r.bc.h,@r.f); {bit 4,B >8t<}
        $61:bit_8(4,r.bc.l,@r.f); {bit 4,C >8t<}
        $62:bit_8(4,r.de.h,@r.f); {bit 4,D >8t<}
        $63:bit_8(4,r.de.l,@r.f); {bit 4,E >8t<}
        $64:bit_8(4,r.hl.h,@r.f); {bit 4,H >8t<}
        $65:bit_8(4,r.hl.l,@r.f); {bit 4,L >8t<}
        $66:begin  {bit 4,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(4,temp,@r.f)
            end;
        $67:bit_8(4,r.a,@r.f); {bit 4,A >8t<}
        $68:bit_8(5,r.bc.h,@r.f); {bit 5,B >8t<}
        $69:bit_8(5,r.bc.l,@r.f); {bit 5,C >8t<}
        $6a:bit_8(5,r.de.h,@r.f); {bit 5,D >8t<}
        $6b:bit_8(5,r.de.l,@r.f); {bit 5,E >8t<}
        $6c:bit_8(5,r.hl.h,@r.f); {bit 5,H >8t<}
        $6d:bit_8(5,r.hl.l,@r.f); {bit 5,L >8t<}
        $6e:begin  {bit 5,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(5,temp,@r.f)
            end;
        $6f:bit_8(5,r.a,@r.f); {bit 5,A >8t<}
        $70:bit_8(6,r.bc.h,@r.f); {bit 6,B >8t<}
        $71:bit_8(6,r.bc.l,@r.f); {bit 6,C >8t<}
        $72:bit_8(6,r.de.h,@r.f); {bit 6,D >8t<}
        $73:bit_8(6,r.de.l,@r.f); {bit 6,E >8t<}
        $74:bit_8(6,r.hl.h,@r.f); {bit 6,H >8t<}
        $75:bit_8(6,r.hl.l,@r.f); {bit 6,L >8t<}
        $76:begin  {bit 6,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit_8(6,temp,@r.f)
            end;
        $77:bit_8(6,r.a,@r.f);  {bit 6,A >8t<}
        $78:bit7(r.bc.h,@r.f); {bit 7,B >8t<}
        $79:bit7(r.bc.l,@r.f); {bit 7,C >8t<}
        $7a:bit7(r.de.h,@r.f); {bit 7,D >8t<}
        $7b:bit7(r.de.l,@r.f); {bit 7,E >8t<}
        $7c:bit7(r.hl.h,@r.f); {bit 7,H >8t<}
        $7d:bit7(r.hl.l,@r.f); {bit 7,L >8t<}
        $7e:begin  {bit 7,(HL) >12t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                bit7(temp,@r.f)
            end;
        $7f:bit7(r.a,@r.f); {bit 7,A >8t<}
        $80:r.bc.h:=(r.bc.h and $fe); {res 0,B >8t<}
        $81:r.bc.l:=(r.bc.l and $fe); {res 0,C >8t<}
        $82:r.de.h:=(r.de.h and $fe); {res 0,D >8t<}
        $83:r.de.l:=(r.de.l and $fe); {res 0,E >8t<}
        $84:r.hl.h:=(r.hl.h and $fe); {res 0,H >8t<}
        $85:r.hl.l:=(r.hl.l and $fe); {res 0,L >8t<}
        $86:begin  {res 0,(hl) >15t<}
                  temp:=(spec_getbyte(r.hl.w,r,ll) and $fe);
                  spec_retraso.retraso(r.hl.w);inc(r.contador);
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $87:r.a:=r.a and $fe; {res 0,A >8t<}
        $88:r.bc.h:=r.bc.h and $fd; {res 1,B >8t<}
        $89:r.bc.l:=r.bc.l and $fd; {res 1,C >8t<}
        $8a:r.de.h:=r.de.h and $fd; {res 1,D >8t<}
        $8b:r.de.l:=r.de.l and $fd; {res 1,E >8t<}
        $8c:r.hl.h:=r.hl.h and $fd; {res 1,H >8t<}
        $8d:r.hl.l:=r.hl.l and $fd; {res 1,L >8t<}
        $8e:begin  {res 1,(hl) >15t<}
                  temp:=(spec_getbyte(r.hl.w,r,ll) and $fd);
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $8f:r.a:=r.a and $fd; {res 1,A >8t<}
        $90:r.bc.h:=r.bc.h and $fb; {res 2,B >8t<}
        $91:r.bc.l:=r.bc.l and $fb; {res 2,C >8t<}
        $92:r.de.h:=r.de.h and $fb; {res 2,D >8t<}
        $93:r.de.l:=r.de.l and $fb; {res 2,E >8t<}
        $94:r.hl.h:=r.hl.h and $fb; {res 2,H >8t<}
        $95:r.hl.l:=r.hl.l and $fb; {res 2,L >8t<}
        $96:begin  {res 2,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) and $fb;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $97:r.a:=r.a and $fb; {res 2,A}
        $98:r.bc.h:=r.bc.h and $f7; {res 3,B >8t<}
        $99:r.bc.l:=r.bc.l and $f7; {res 3,C >8t<}
        $9a:r.de.h:=r.de.h and $f7; {res 3,D >8t<}
        $9b:r.de.l:=r.de.l and $f7; {res 3,E >8t<}
        $9c:r.hl.h:=r.hl.h and $f7; {res 3,H >8t<}
        $9d:r.hl.l:=r.hl.l and $f7; {res 3,L >8t<}
        $9e:begin  {res 3,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) and $f7;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $9f:r.a:=r.a and $f7; {res 3,A}
        $a0:r.bc.h:=r.bc.h and $ef; {res 4,B >8t<}
        $a1:r.bc.l:=r.bc.l and $ef; {res 4,C >8t<}
        $a2:r.de.h:=r.de.h and $ef; {res 4,D >8t<}
        $a3:r.de.l:=r.de.l and $ef; {res 4,E >8t<}
        $a4:r.hl.h:=r.hl.h and $ef; {res 4,H >8t<}
        $a5:r.hl.l:=r.hl.l and $ef; {res 4,L >8t<}
        $a6:begin  {res 4,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) and $ef;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $a7:r.a:=r.a and $ef; {res 4,A >8t<}
        $a8:r.bc.h:=r.bc.h and $df; {res 5,B >8t<}
        $a9:r.bc.l:=r.bc.l and $df; {res 5,C >8t<}
        $aa:r.de.h:=r.de.h and $df; {res 5,D >8t<}
        $ab:r.de.l:=r.de.l and $df; {res 5,E >8t<}
        $ac:r.hl.h:=r.hl.h and $df; {res 5,H >8t<}
        $ad:r.hl.l:=r.hl.l and $df; {res 5,L >8t<}
        $ae:begin  {res 5,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) and $df;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $af:r.a:=r.a and $df; {res 5,A >8t<}
        $b0:r.bc.h:=r.bc.h and $bf; {res 6,B >8t<}
        $b1:r.bc.l:=r.bc.l and $bf; {res 6,C >8t<}
        $b2:r.de.h:=r.de.h and $bf; {res 6,D >8t<}
        $b3:r.de.l:=r.de.l and $bf; {res 6,E >8t<}
        $b4:r.hl.h:=r.hl.h and $bf; {res 6,H >8t<}
        $b5:r.hl.l:=r.hl.l and $bf; {res 6,L >8t<}
        $b6:begin  {res 6,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) and $bf;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $b7:r.a:=r.a and $bf; {res 6,A >8t<}
        $b8:r.bc.h:=r.bc.h and $7f; {res 7,B >8t<}
        $b9:r.bc.l:=r.bc.l and $7f; {res 7,C >8t<}
        $ba:r.de.h:=r.de.h and $7f; {res 7,D >8t<}
        $bb:r.de.l:=r.de.l and $7f; {res 7,E >8t<}
        $bc:r.hl.h:=r.hl.h and $7f; {res 7,H >8t<}
        $bd:r.hl.l:=r.hl.l and $7f; {res 7,L >8t<}
        $be:begin  {res 7,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) and $7f;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $bf:r.a:=r.a and $7f; {res 7,A >8t<}
        $c0:r.bc.h:=r.bc.h or $1; {set 0,B >8t<}
        $c1:r.bc.l:=r.bc.l or $1; {set 0,C >8t<}
        $c2:r.de.h:=r.de.h or $1; {set 0,D >8t<}
        $c3:r.de.l:=r.de.l or $1; {set 0,E >8t<}
        $c4:r.hl.h:=r.hl.h or $1; {set 0,H >8t<}
        $c5:r.hl.l:=r.hl.l or $1; {set 0,L >8t<}
        $c6:begin  {set 0,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or 1;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $c7:r.a:=r.a or $1; {set 0,A >8t<}
        $c8:r.bc.h:=r.bc.h or $2; {set 1,B >8t<}
        $c9:r.bc.l:=r.bc.l or $2; {set 1,C >8t<}
        $ca:r.de.h:=r.de.h or $2; {set 1,D >8t<}
        $cb:r.de.l:=r.de.l or $2; {set 1,E >8t<}
        $cc:r.hl.h:=r.hl.h or $2; {set 1,H >8t<}
        $cd:r.hl.l:=r.hl.l or $2; {set 1,L >8t<}
        $ce:begin  {set 1,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or 2;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $cf:r.a:=r.a or $2; {set 1,A >8t<}
        $d0:r.bc.h:=r.bc.h or $4; {set 2,B >8t<}
        $d1:r.bc.l:=r.bc.l or $4; {set 2,C >8t<}
        $d2:r.de.h:=r.de.h or $4; {set 2,D >8t<}
        $d3:r.de.l:=r.de.l or $4; {set 2,E >8t<}
        $d4:r.hl.h:=r.hl.h or $4; {set 2,H >8t<}
        $d5:r.hl.l:=r.hl.l or $4; {set 2,L >8t<}
        $d6:begin  {set 2,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or 4;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $d7:r.a:=r.a or $4; {set 2,A >8t<}
        $d8:r.bc.h:=r.bc.h or $8; {set 3,B >8t<}
        $d9:r.bc.l:=r.bc.l or $8; {set 3,C >8t<}
        $da:r.de.h:=r.de.h or $8; {set 3,D >8t<}
        $db:r.de.l:=r.de.l or $8; {set 3,E >8t<}
        $dc:r.hl.h:=r.hl.h or $8; {set 3,H >8t<}
        $dd:r.hl.l:=r.hl.l or $8; {set 3,L >8t<}
        $de:begin  {set 3,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or 8;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $df:r.a:=r.a or $8; {set 3,A >8t<}
        $e0:r.bc.h:=r.bc.h or $10; {set 4,B >8t<}
        $e1:r.bc.l:=r.bc.l or $10; {set 4,C >8t<}
        $e2:r.de.h:=r.de.h or $10; {set 4,D >8t<}
        $e3:r.de.l:=r.de.l or $10; {set 4,E >8t<}
        $e4:r.hl.h:=r.hl.h or $10; {set 4,H >8t<}
        $e5:r.hl.l:=r.hl.l or $10; {set 4,L >8t<}
        $e6:begin  {set 4,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or $10;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $e7:r.a:=r.a or $10; {set 4,A >8t<}
        $e8:r.bc.h:=r.bc.h or $20; {set 5,B >8t<}
        $e9:r.bc.l:=r.bc.l or $20; {set 5,C >8t<}
        $ea:r.de.h:=r.de.h or $20; {set 5,D >8t<}
        $eb:r.de.l:=r.de.l or $20; {set 5,E >8t<}
        $ec:r.hl.h:=r.hl.h or $20; {set 5,H >8t<}
        $ed:r.hl.l:=r.hl.l or $20; {set 5,L >8t<}
        $ee:begin  {set 5,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or $20;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $ef:r.a:=r.a or $20; {set 5,A >8t<}
        $f0:r.bc.h:=r.bc.h or $40; {set 6,B >8t<}
        $f1:r.bc.l:=r.bc.l or $40; {set 6,C >8t<}
        $f2:r.de.h:=r.de.h or $40; {set 6,D >8t<}
        $f3:r.de.l:=r.de.l or $40; {set 6,E >8t<}
        $f4:r.hl.h:=r.hl.h or $40; {set 6,H >8t<}
        $f5:r.hl.l:=r.hl.l or $40; {set 6,L >8t<}
        $f6:begin  {set 6,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or $40;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $f7:r.a:=r.a or $40; {set 6,A >8t<}
        $f8:r.bc.h:=r.bc.h or $80; {set 7,B >8t<}
        $f9:r.bc.l:=r.bc.l or $80; {set 7,C >8t<}
        $fa:r.de.h:=r.de.h or $80; {set 7,D >8t<}
        $fb:r.de.l:=r.de.l or $80; {set 7,E >8t<}
        $fc:r.hl.h:=r.hl.h or $80; {set 7,H >8t<}
        $fd:r.hl.l:=r.hl.l or $80; {set 7,L >8t<}
        $fe:begin  {set 7,(HL) >15t<}
                  temp:=spec_getbyte(r.hl.w,r,ll) or $80;
                  spec_retraso.retraso(r.hl.w);inc(r.contador); 
                  spec_putbyte(r.hl.w,temp,r,ll);
             end;
        $ff:r.a:=r.a or $80; {set 7,A >8t<}
end;
end;

end.
