unit jailbreak_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,main_engine,controls_engine,sn_76496,vlm_5030,gfx_engine,
     timer_engine,rom_engine,cpu_engine,pal_engine,konami_decrypt,sound_engine;

//main
procedure Cargar_jailbreak;
procedure jailbreak_principal; 
function iniciar_jailbreak:boolean; 
procedure reset_jailbreak; 
procedure cerrar_jailbreak; 
//cpu
function jailbreak_getbyte(direccion:word): Byte;  
procedure jailbreak_putbyte(direccion:word;valor:byte); 
procedure jailbreak_despues_instruccion;
procedure jailbreak_snd_nmi;

const
        jailbreak_rom:array[0..2] of tipo_roms=(
        (n:'507p03.11d';l:$4000;p:$8000;crc:$a0b88dfd),(n:'507p02.9d';l:$4000;p:$c000;crc:$444b7d8e),());
        jailbreak_char:array[0..2] of tipo_roms=(
        (n:'507l08.4f';l:$4000;p:0;crc:$e3b7a226),(n:'507j09.5f';l:$4000;p:$4000;crc:$504f0912),());
        jailbreak_sprites:array[0..4] of tipo_roms=(
        (n:'507j04.3e';l:$4000;p:0;crc:$0d269524),(n:'507j05.4e';l:$4000;p:$4000;crc:$27d4f6f4),
        (n:'507j06.5e';l:$4000;p:$8000;crc:$717485cb),(n:'507j07.3f';l:$4000;p:$c000;crc:$e933086f),());
        jailbreak_pal:array[0..4] of tipo_roms=(
        (n:'507j10.1f';l:$20;p:0;crc:$f1909605),(n:'507j11.2f';l:$20;p:$20;crc:$f70bb122),
        (n:'507j13.7f';l:$100;p:$40;crc:$d4fe5c97),(n:'507j12.6f';l:$100;p:$140;crc:$0266c7db),());
        jailbreak_vlm:tipo_roms=(n:'507l01.8c';l:$4000;p:$0;crc:$0c8a3605);

var
 pedir_irq,pedir_nmi:boolean;
 mem_opcodes:array[0..$7fff] of byte;
 scroll_lineas:array[0..$1f] of parejas;

implementation
uses principal;

procedure Cargar_jailbreak;
begin
llamadas_maquina.iniciar:=iniciar_jailbreak;
llamadas_maquina.bucle_general:=jailbreak_principal;
llamadas_maquina.cerrar:=cerrar_jailbreak;
llamadas_maquina.reset:=reset_jailbreak;
llamadas_maquina.fps_max:=60.606060606060;
end;

function iniciar_jailbreak:boolean;
var
      colores:tpaleta;
      f:word;
      memoria_temp:array[0..$ffff] of byte;
const
    pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
    pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
    ps_x:array[0..15] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
			32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4);
    ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
begin
iniciar_jailbreak:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=511;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1536000);
main_6809_ll.getbyte:=jailbreak_getbyte;
main_6809_ll.putbyte:=jailbreak_putbyte;
//Sound Chip
SN76496_init(0,1536000);
init_sound_engine(0,1536000,jailbreak_despues_instruccion);
//cargar rom sonido
vlm5030_init(2,3579545,$4000,0,1536000);
if not(cargar_roms(chip_vlm.rom,@jailbreak_vlm,'jailbrek.zip',1)) then exit;
//NMI sonido
init_timer(0,1536000/480,jailbreak_snd_nmi,true);
//cargar roms y desencriptarlas
if not(cargar_roms(@memoria[0],@jailbreak_rom[0],'jailbrek.zip',0)) then exit;
konami1_decode(@memoria[0],@mem_opcodes[0],$8000);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@jailbreak_char[0],'jailbrek.zip',0)) then exit;
init_gfx(0,8,8,1024);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@jailbreak_sprites[0],'jailbrek.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.long_sprites:=128*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@jailbreak_pal[0],'jailbrek.zip',0)) then exit;
for f:=0 to $1f do begin
  colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
  colores[f].g:=((memoria_temp[f] shr 4) shl 4) or (memoria_temp[f] shr 4);
  colores[f].b:=((memoria_temp[f+$20] and $f) shl 4) or (memoria_temp[f+$20] and $f);
end;
set_pal(colores,32);
for f:=0 to $ff do begin
  gfx[0].colores[f]:=(memoria_temp[$40+f] and $f)+$10;  //chars
  gfx[1].colores[f]:=memoria_temp[$140+f] and $f;  //sprites
end;
//final
reset_jailbreak;
iniciar_jailbreak:=true;
end;

procedure cerrar_jailbreak; 
begin
cerrar_cpus;
SN76496_close(0);
vlm5030_close;
close_audio;
close_video;
end;

procedure reset_jailbreak; 
begin
 reset_6809(main_6809,main_6809_ll);
 SN76496_reset(0);
 vlm5030_reset;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_irq:=false;
 pedir_nmi:=false;
end;

procedure update_video_jailbreak;inline;
var
  y,atrib:byte;
  f,x:word;
  nchar,color:word;
begin
for f:=0 to $7ff do begin
    if gfx[0].buffer[f] then begin
      x:=f mod 64;
      y:=f div 64;
      atrib:=memoria[$0+f];
      nchar:=memoria[$800+f]+((atrib and $c0) shl 2);
      color:=(atrib and $f) shl 4;
      put_gfx(x*8,y*8,nchar,color,1,0);
      gfx[0].buffer[f]:=false;
    end;
end;
for f:=0 to 31 do scroll__x_part(1,2,scroll_lineas[f].w,0,f*8,8);
for f:=0 to $2f do begin
  atrib:=memoria[$1001+(f*4)];
  nchar:=memoria[$1000+(f*4)]+((atrib and $40) shl 2);
  color:=(atrib and $f) shl 4;
  x:=memoria[$1002+(f*4)]+((atrib and $80) shl 1);
  y:=memoria[$1003+(f*4)];
  put_gfx_sprite_mask(nchar,color,(atrib and $10)<>0,(atrib and $20)<>0,1,0,$f);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo_final(8,16,240,224,2);
end;

procedure eventos_jailbreak;
begin
if event.arcade then begin
  if arcade_input.left[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.right[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.up[0] then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.coin[0] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.coin[1] then in2:=(in2 and $fd) else in2:=(in2 or $2);
  if arcade_input.start[0] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if arcade_input.start[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
end;
end;

procedure jailbreak_principal; 
var
  frame:single;
begin
init_controls(false,false,false,true);
frame:=main_6809.tframes;
while EmuStatus=EsRuning do begin
  run_6809(main_6809,main_6809_ll,trunc(frame));
  frame:=frame+main_6809.tframes-main_6809.contador;
  if pedir_irq then main_6809.pedir_irq:=HOLD_LINE;
  update_video_jailbreak;
  eventos_jailbreak;
  video_sync;
end;
end;

function jailbreak_getbyte(direccion:word):byte;
begin
case direccion of
  $3100:jailbreak_getbyte:=$59;
  $3200:jailbreak_getbyte:=$f;
  $3300:jailbreak_getbyte:=in2;
  $3301:jailbreak_getbyte:=in0;
  $3302..$3303:jailbreak_getbyte:=$ff;
  $6000:jailbreak_getbyte:=VLM5030_BSY;
  $8000..$ffff:if main_6809.opcode then jailbreak_getbyte:=mem_opcodes[direccion and $7fff]
    else jailbreak_getbyte:=memoria[direccion];
  else jailbreak_getbyte:=memoria[direccion];
end;
end;

procedure jailbreak_putbyte(direccion:word;valor:byte);
begin
if direccion>$7FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $0..$fff:gfx[0].buffer[direccion and $7ff]:=true;
  $2000..$201f:scroll_lineas[direccion and $1f].l:=valor;
  $2020..$203f:scroll_lineas[direccion and $1f].h:=valor and 1;
  $2042:;//if (valor and $4)<>0 then halt(0); Scroll vertical?
  $2044:begin
          pedir_nmi:=((valor and $1)<>0);
          pedir_irq:=((valor and $2)<>0);
        end;
  $3100:SN76496_Write(0,valor);
  $4000:begin
           VLM5030_ST((valor shr 1) and 1);
	         VLM5030_RST((valor shr 2 ) and 1 );
        end;
  $5000:VLM5030_data_w(valor);
end;
end;

procedure jailbreak_snd_nmi;
begin
  if pedir_nmi then main_6809.pedir_nmi:=PULSE_LINE;
end;

procedure jailbreak_despues_instruccion;
begin
  SN76496_Update(0);
end;

end.
