unit nec_ea;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     dialogs,sysutils,nec_v20_v30;

function GetEA(ModRM:byte;r:preg_nec;ll:llam_nec):dword;

implementation

function GetEA(ModRM:byte;r:preg_nec;ll:llam_nec):dword;
var
  EO:dword;
  EA:dword;
  tempb:byte;
  E16:word;
begin
if r.ea_calculated then begin
  GetEA:=r.EA;
  exit;
end;
case ModRM of
  $00,$08,$10,$18,$20,$28,$30,$38:begin
        EO:=r.bw.w+r.ix.w;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $01,$09,$11,$19,$21,$29,$31,$39:begin
        EO:=r.bw.w+r.iy.w;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $04,$0c,$14,$1c,$24,$2c,$34,$3c:begin
        EO:=r.ix.w;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $05,$0d,$15,$1d,$25,$2d,$35,$3d:begin
        EO:=r.iy.w;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $06,$0e,$16,$1e,$26,$2e,$36,$3e:begin
        EO:=fetch(r,ll);
        EO:=EO+(FETCH(r,ll) shl 8);
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $07,$0f,$17,$1f,$27,$2f,$37,$3f:begin
        EO:=r.bw.w;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $40,$48,$50,$58,$60,$68,$70,$78:begin
        tempb:=fetch(r,ll);
        if (tempb and $80)<>0 then EO:=(r.bw.w+r.ix.w)-($100-tempb)
          else EO:=r.bw.w+r.ix.w+tempb;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $44,$4c,$54,$5c,$64,$6c,$74,$7c:begin
        tempb:=fetch(r,ll);
        if (tempb and $80)<>0 then EO:=r.ix.w-($100-tempb)
          else EO:=r.ix.w+tempb;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $45,$4d,$55,$5d,$65,$6d,$75,$7d:begin
        tempb:=fetch(r,ll);
        if (tempb and $80)<>0 then EO:=r.iy.w-($100-tempb)
          else EO:=r.iy.w+tempb;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $46,$4e,$56,$5e,$66,$6e,$76,$7e:begin
        tempb:=fetch(r,ll);
        if (tempb and $80)<>0 then EO:=r.bp.w-($100-tempb)
          else EO:=r.bp.w+tempb;
        EA:=DefaultBase(SS,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $47,$4f,$57,$5f,$67,$6f,$77,$7f:begin
        tempb:=fetch(r,ll);
        if (tempb and $80)<>0 then EO:=r.bw.w-($100-tempb)
          else EO:=r.bw.w+tempb;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $80,$88,$90,$98,$a0,$a8,$b0,$b8:begin
        E16:=FETCH(r,ll);
        E16:=E16+(FETCH(r,ll) shl 8);
        if (E16 and $8000)<>0 then EO:=(r.bw.w+r.ix.w)-($10000-E16)
            else EO:=r.bw.w+r.ix.w+E16;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $81,$89,$91,$99,$a1,$a9,$b1,$b9:begin
        E16:=FETCH(r,ll);
        E16:=E16+(FETCH(r,ll) shl 8);
        if (E16 and $8000)<>0 then EO:=(r.bw.w+r.iy.w)-($10000-E16)
            else EO:=r.bw.w+r.iy.w+E16;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $84,$8c,$94,$9c,$a4,$ac,$b4,$bc:begin
        E16:=FETCH(r,ll);
        E16:=E16+(FETCH(r,ll) shl 8);
        if (E16 and $8000)<>0 then EO:=r.ix.w-($10000-E16)
            else EO:=r.ix.w+E16;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  $87,$8f,$97,$9f,$a7,$af,$b7,$bf:begin
        E16:=FETCH(r,ll);
        E16:=E16+(FETCH(r,ll) shl 8);
        if (E16 and $8000)<>0 then EO:=r.bw.w-($10000-E16)
            else EO:=r.bw.w+E16;
        EA:=DefaultBase(DS0,r)+(EO and $ffff);
        GetEA:=EA;
      end;
  else MessageDlg('GetEA No Implementado ModRM'+inttostr(ModRM), mtInformation,[mbOk], 0);
end;
r.ea_calculated:=true;
end;

end.
