unit z80_cb;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses z80;

const
        z80t_cb:array[0..255] of byte=(
      //0 1 2 3 4 5  6 7 8 9 a b c d  e f
        8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,12, 8, 8, 8, 8, 8, 8, 8,12, 8,
 8, 8, 8, 8, 8, 8,12, 8, 8, 8, 8, 8, 8, 8,12, 8,
 8, 8, 8, 8, 8, 8,12, 8, 8, 8, 8, 8, 8, 8,12, 8,
 8, 8, 8, 8, 8, 8,12, 8, 8, 8, 8, 8, 8, 8,12, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
 8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8,
   8, 8, 8, 8, 8, 8,15, 8, 8, 8, 8, 8, 8, 8,15, 8);

function exec_cb(r:preg_z80;ll:llam_z80):byte;
procedure bit_8(bit,valor:byte;reg:pband_z80);
procedure bit7(valor:byte;reg:pband_z80);

implementation

function exec_cb(r:preg_z80;ll:llam_z80):byte;
var
        instruccion,temp:byte;
begin
r.opcode:=true;
instruccion:=ll.getbyte(r.pc);
r.opcode:=false;
r.pc:=r.pc+1;
r.r:=((r.r+1) and $7f) or (r.r and $80);
case instruccion of
        $00:rlc_8(r,@r.bc.h); {rlc B}
        $01:rlc_8(r,@r.bc.l); {rlc C}
        $02:rlc_8(r,@r.de.h); {rlc D}
        $03:rlc_8(r,@r.de.l); {rlc E}
        $04:rlc_8(r,@r.hl.h); {rlc H}
        $05:rlc_8(r,@r.hl.l); {rlc L}
        $06:begin
                temp:=ll.getbyte(r.hl.w);
                rlc_8(r,@temp); {rlc (HL)}
                ll.putbyte(r.hl.w,temp);
            end;
        $07:rlc_8(r,@r.a); {rlc A}
        $08:rrc_8(r,@r.bc.h); {rlc B}
        $09:rrc_8(r,@r.bc.l); {rlc C}
        $0a:rrc_8(r,@r.de.h); {rlc D}
        $0b:rrc_8(r,@r.de.l); {rlc E}
        $0c:rrc_8(r,@r.hl.h); {rlc H}
        $0d:rrc_8(r,@r.hl.l); {rlc L}
        $0e:begin
                temp:=ll.getbyte(r.hl.w);
                rrc_8(r,@temp); {rlc (HL)}
                ll.putbyte(r.hl.w,temp);
            end;
        $0f:rrc_8(r,@r.a); {rlc A}
        $10:rl_8(r,@r.bc.h); {rl B}
        $11:rl_8(r,@r.bc.l); {rl C}
        $12:rl_8(r,@r.de.h); {rl D}
        $13:rl_8(r,@r.de.l); {rl E}
        $14:rl_8(r,@r.hl.h); {rl H}
        $15:rl_8(r,@r.hl.l); {rl L}
        $16:begin
                temp:=ll.getbyte(r.hl.w);
                rl_8(r,@temp); {rl (HL)}
                ll.putbyte(r.hl.w,temp);
            end;
        $17:rl_8(r,@r.a); {rl A}
        $18:rr_8(r,@r.bc.h); {rr B}
        $19:rr_8(r,@r.bc.l); {rr C}
        $1a:rr_8(r,@r.de.h); {rr D}
        $1b:rr_8(r,@r.de.l); {rr E}
        $1c:rr_8(r,@r.hl.h); {rr H}
        $1d:rr_8(r,@r.hl.l); {rr L}
        $1e:begin
                temp:=ll.getbyte(r.hl.w);
                rr_8(r,@temp); {rr (HL)}
                ll.putbyte(r.hl.w,temp);
            end;
        $1f:rr_8(r,@r.a); {rr A}
        $20:sla_8(r,@r.bc.h); {sla B}
        $21:sla_8(r,@r.bc.l); {sla C}
        $22:sla_8(r,@r.de.h); {sla D}
        $23:sla_8(r,@r.de.l); {sla E}
        $24:sla_8(r,@r.hl.h); {sla H}
        $25:sla_8(r,@r.hl.l); {sla L}
        $26:begin
                temp:=ll.getbyte(r.hl.w);
                sla_8(r,@temp); {sla (HL)}
                ll.putbyte(r.hl.w,temp);
            end;
        $27:sla_8(r,@r.a); {sla A}
        $28:sra_8(r,@r.bc.h); {sra B}
        $29:sra_8(r,@r.bc.l); {sra C}
        $2a:sra_8(r,@r.de.h); {sra D}
        $2b:sra_8(r,@r.de.l); {sra E}
        $2c:sra_8(r,@r.hl.h); {sra H}
        $2d:sra_8(r,@r.hl.l); {sra L}
        $2e:begin
                temp:=ll.getbyte(r.hl.w);
                sra_8(r,@temp); {sra (HL)}
                ll.putbyte(r.hl.w,temp);
            end;
        $2f:sra_8(r,@r.a); {sra A}
        $30:sll_8(r,@r.bc.h); {sll B}
        $31:sll_8(r,@r.bc.l); {sll C}
        $32:sll_8(r,@r.de.h); {sll D}
        $33:sll_8(r,@r.de.l); {sll E}
        $34:sll_8(r,@r.hl.h); {sll H}
        $35:sll_8(r,@r.hl.l); {sll L}
        $36:begin  {sll (HL)}
                temp:=ll.getbyte(r.hl.w);
                sll_8(r,@temp);
                ll.putbyte(r.hl.w,temp);
            end;
        $37:sll_8(r,@r.a); {sll a}
        $38:srl_8(r,@r.bc.h); {srl B}
        $39:srl_8(r,@r.bc.l); {srl C}
        $3a:srl_8(r,@r.de.h); {srl D}
        $3b:srl_8(r,@r.de.l); {srl E}
        $3c:srl_8(r,@r.hl.h); {srl H}
        $3d:srl_8(r,@r.hl.l); {srl L}
        $3e:begin  {srl (HL)}
                temp:=ll.getbyte(r.hl.w);
                srl_8(r,@temp);
                ll.putbyte(r.hl.w,temp);
            end;
        $3f:srl_8(r,@r.a); {srl a}
        $40:bit_8(0,r.bc.h,@r.f);  {bit 0,B}
        $41:bit_8(0,r.bc.l,@r.f);  {bit 0,C}
        $42:bit_8(0,r.de.h,@r.f);  {bit 0,D}
        $43:bit_8(0,r.de.l,@r.f);  {bit 0,E}
        $44:bit_8(0,r.hl.h,@r.f);  {bit 0,H}
        $45:bit_8(0,r.hl.l,@r.f);  {bit 0,L}
        $46:bit_8(0,ll.getbyte(r.hl.w),@r.f); {bit 0,(HL)}
        $47:bit_8(0,r.a,@r.f);  {bit 0,A}
        $48:bit_8(1,r.bc.h,@r.f);  {bit 1,B}
        $49:bit_8(1,r.bc.l,@r.f);  {bit 1,C}
        $4a:bit_8(1,r.de.h,@r.f);  {bit 1,D}
        $4b:bit_8(1,r.de.l,@r.f);  {bit 1,E}
        $4c:bit_8(1,r.hl.h,@r.f);  {bit 1,H}
        $4d:bit_8(1,r.hl.l,@r.f);  {bit 1,L}
        $4e:bit_8(1,ll.getbyte(r.hl.w),@r.f);  {bit 1,(HL)}
        $4f:bit_8(1,r.a,@r.f);  {bit 1,A}
        $50:bit_8(2,r.bc.h,@r.f);  {bit 2,B}
        $51:bit_8(2,r.bc.l,@r.f);  {bit 2,C}
        $52:bit_8(2,r.de.h,@r.f);  {bit 2,D}
        $53:bit_8(2,r.de.l,@r.f);  {bit 2,E}
        $54:bit_8(2,r.hl.h,@r.f);  {bit 2,H}
        $55:bit_8(2,r.hl.l,@r.f);  {bit 2,L}
        $56:bit_8(2,ll.getbyte(r.hl.w),@r.f);  {bit 2,(HL)}
        $57:bit_8(2,r.a,@r.f);  {bit 2,A}
        $58:bit_8(3,r.bc.h,@r.f);  {bit 3,B}
        $59:bit_8(3,r.bc.l,@r.f);  {bit 3,C}
        $5a:bit_8(3,r.de.h,@r.f);  {bit 3,D}
        $5b:bit_8(3,r.de.l,@r.f);  {bit 3,E}
        $5c:bit_8(3,r.hl.h,@r.f);  {bit 3,H}
        $5d:bit_8(3,r.hl.l,@r.f);  {bit 3,L}
        $5e:bit_8(3,ll.getbyte(r.hl.w),@r.f);  {bit 3,(HL)}
        $5f:bit_8(3,r.a,@r.f);  {bit 3,A}
        $60:bit_8(4,r.bc.h,@r.f);  {bit 4,B}
        $61:bit_8(4,r.bc.l,@r.f);  {bit 4,C}
        $62:bit_8(4,r.de.h,@r.f);  {bit 4,D}
        $63:bit_8(4,r.de.l,@r.f);  {bit 4,E}
        $64:bit_8(4,r.hl.h,@r.f);  {bit 4,H}
        $65:bit_8(4,r.hl.l,@r.f);  {bit 4,L}
        $66:bit_8(4,ll.getbyte(r.hl.w),@r.f); {bit 4,(HL)}
        $67:bit_8(4,r.a,@r.f);  {bit 4,A}
        $68:bit_8(5,r.bc.h,@r.f);  {bit 5,B}
        $69:bit_8(5,r.bc.l,@r.f);  {bit 5,C}
        $6a:bit_8(5,r.de.h,@r.f);  {bit 5,D}
        $6b:bit_8(5,r.de.l,@r.f);  {bit 5,E}
        $6c:bit_8(5,r.hl.h,@r.f);  {bit 5,H}
        $6d:bit_8(5,r.hl.l,@r.f);  {bit 5,L}
        $6e:bit_8(5,ll.getbyte(r.hl.w),@r.f); {bit 5,(HL)}
        $6f:bit_8(5,r.a,@r.f);  {bit 5,A}
        $70:bit_8(6,r.bc.h,@r.f);  {bit 6,B}
        $71:bit_8(6,r.bc.l,@r.f);  {bit 6,C}
        $72:bit_8(6,r.de.h,@r.f);  {bit 6,D}
        $73:bit_8(6,r.de.l,@r.f);  {bit 6,E}
        $74:bit_8(6,r.hl.h,@r.f);  {bit 6,H}
        $75:bit_8(6,r.hl.l,@r.f);  {bit 6,L}
        $76:bit_8(6,ll.getbyte(r.hl.w),@r.f); {bit 6,(HL)}
        $77:bit_8(6,r.a,@r.f);  {bit 6,A}
        $78:bit7(r.bc.h,@r.f);  {bit 7,B}
        $79:bit7(r.bc.l,@r.f);  {bit 7,C}
        $7a:bit7(r.de.h,@r.f);  {bit 7,D}
        $7b:bit7(r.de.l,@r.f);  {bit 7,E}
        $7c:bit7(r.hl.h,@r.f);  {bit 7,H}
        $7d:bit7(r.hl.l,@r.f);  {bit 7,L}
        $7e:bit7(ll.getbyte(r.hl.w),@r.f);  {bit 7,(HL)}
        $7f:bit7(r.a,@r.f);  {bit 7,A}
        $80:r.bc.h:=(r.bc.h and $fe); {res 0,B}
        $81:r.bc.l:=(r.bc.l and $fe); {res 0,C}
        $82:r.de.h:=(r.de.h and $fe); {res 0,D}
        $83:r.de.l:=(r.de.l and $fe); {res 0,E}
        $84:r.hl.h:=(r.hl.h and $fe); {res 0,H}
        $85:r.hl.l:=(r.hl.l and $fe); {res 0,L}
        $86:begin  {res 0,(hl)}
                  temp:=(ll.getbyte(r.hl.w) and $fe);
                  ll.putbyte(r.hl.w,temp);
             end;
        $87:r.a:=r.a and $fe; {res 0,A}
        $88:r.bc.h:=r.bc.h and $fd; {res 1,B}
        $89:r.bc.l:=r.bc.l and $fd; {res 1,C}
        $8a:r.de.h:=r.de.h and $fd; {res 1,D}
        $8b:r.de.l:=r.de.l and $fd; {res 1,E}
        $8c:r.hl.h:=r.hl.h and $fd; {res 1,H}
        $8d:r.hl.l:=r.hl.l and $fd; {res 1,L}
        $8e:begin  {res 1,(hl)}
                  temp:=(ll.getbyte(r.hl.w) and $fd);
                  ll.putbyte(r.hl.w,temp);
             end;
        $8f:r.a:=r.a and $fd; {res 1,A}
        $90:r.bc.h:=r.bc.h and $fb; {res 2,B}
        $91:r.bc.l:=r.bc.l and $fb; {res 2,C}
        $92:r.de.h:=r.de.h and $fb; {res 2,D}
        $93:r.de.l:=r.de.l and $fb; {res 2,E}
        $94:r.hl.h:=r.hl.h and $fb; {res 2,H}
        $95:r.hl.l:=r.hl.l and $fb; {res 2,L}
        $96:begin  {res 2,(HL)}
                  temp:=ll.getbyte(r.hl.w) and $fb;
                  ll.putbyte(r.hl.w,temp);
             end;
        $97:r.a:=r.a and $fb; {res 2,A}
        $98:r.bc.h:=r.bc.h and $f7; {res 3,B}
        $99:r.bc.l:=r.bc.l and $f7; {res 3,C}
        $9a:r.de.h:=r.de.h and $f7; {res 3,D}
        $9b:r.de.l:=r.de.l and $f7; {res 3,E}
        $9c:r.hl.h:=r.hl.h and $f7; {res 3,H}
        $9d:r.hl.l:=r.hl.l and $f7; {res 3,L}
        $9e:begin  {res 3,(HL)}
                  temp:=ll.getbyte(r.hl.w) and $f7;
                  ll.putbyte(r.hl.w,temp);
             end;
        $9f:r.a:=r.a and $f7; {res 3,A}
        $a0:r.bc.h:=r.bc.h and $ef; {res 4,B}
        $a1:r.bc.l:=r.bc.l and $ef; {res 4,C}
        $a2:r.de.h:=r.de.h and $ef; {res 4,D}
        $a3:r.de.l:=r.de.l and $ef; {res 4,E}
        $a4:r.hl.h:=r.hl.h and $ef; {res 4,H}
        $a5:r.hl.l:=r.hl.l and $ef; {res 4,L}
        $a6:begin  {res 4,(HL)}
                  temp:=ll.getbyte(r.hl.w) and $ef;
                  ll.putbyte(r.hl.w,temp);
             end;
        $a7:r.a:=r.a and $ef; {res 4,A}
        $a8:r.bc.h:=r.bc.h and $df; {res 5,B}
        $a9:r.bc.l:=r.bc.l and $df; {res 5,C}
        $aa:r.de.h:=r.de.h and $df; {res 5,D}
        $ab:r.de.l:=r.de.l and $df; {res 5,E}
        $ac:r.hl.h:=r.hl.h and $df; {res 5,H}
        $ad:r.hl.l:=r.hl.l and $df; {res 5,L}
        $ae:begin  {res 5,(HL)}
                  temp:=ll.getbyte(r.hl.w) and $df;
                  ll.putbyte(r.hl.w,temp);
             end;
        $af:r.a:=r.a and $df; {res 5,A}
        $b0:r.bc.h:=r.bc.h and $bf; {res 6,B}
        $b1:r.bc.l:=r.bc.l and $bf; {res 6,C}
        $b2:r.de.h:=r.de.h and $bf; {res 6,D}
        $b3:r.de.l:=r.de.l and $bf; {res 6,E}
        $b4:r.hl.h:=r.hl.h and $bf; {res 6,H}
        $b5:r.hl.l:=r.hl.l and $bf; {res 6,L}
        $b6:begin  {res 6,(HL)}
                  temp:=ll.getbyte(r.hl.w) and $bf;
                  ll.putbyte(r.hl.w,temp);
             end;
        $b7:r.a:=r.a and $bf; {res 6,A}
        $b8:r.bc.h:=r.bc.h and $7f; {res 7,B}
        $b9:r.bc.l:=r.bc.l and $7f; {res 7,C}
        $ba:r.de.h:=r.de.h and $7f; {res 7,D}
        $bb:r.de.l:=r.de.l and $7f; {res 7,E}
        $bc:r.hl.h:=r.hl.h and $7f; {res 7,H}
        $bd:r.hl.l:=r.hl.l and $7f; {res 7,L}
        $be:begin  {res 7,(HL)}
                  temp:=ll.getbyte(r.hl.w) and $7f;
                  ll.putbyte(r.hl.w,temp);
             end;
        $bf:r.a:=r.a and $7f; {res 7,A}
        $c0:r.bc.h:=r.bc.h or $1; {set 0,B}
        $c1:r.bc.l:=r.bc.l or $1; {set 0,C}
        $c2:r.de.h:=r.de.h or $1; {set 0,D}
        $c3:r.de.l:=r.de.l or $1; {set 0,E}
        $c4:r.hl.h:=r.hl.h or $1; {set 0,H}
        $c5:r.hl.l:=r.hl.l or $1; {set 0,L}
        $c6:begin  {set 0,(HL)}
                  temp:=ll.getbyte(r.hl.w) or 1;
                  ll.putbyte(r.hl.w,temp);
             end;
        $c7:r.a:=r.a or $1; {set 0,A}
        $c8:r.bc.h:=r.bc.h or $2; {set 1,B}
        $c9:r.bc.l:=r.bc.l or $2; {set 1,C}
        $ca:r.de.h:=r.de.h or $2; {set 1,D}
        $cb:r.de.l:=r.de.l or $2; {set 1,E}
        $cc:r.hl.h:=r.hl.h or $2; {set 1,H}
        $cd:r.hl.l:=r.hl.l or $2; {set 1,L}
        $ce:begin  {set 1,(HL)}
                  temp:=ll.getbyte(r.hl.w) or 2;
                  ll.putbyte(r.hl.w,temp);
             end;
        $cf:r.a:=r.a or $2; {set 1,A}
        $d0:r.bc.h:=r.bc.h or $4; {set 2,B}
        $d1:r.bc.l:=r.bc.l or $4; {set 2,C}
        $d2:r.de.h:=r.de.h or $4; {set 2,D}
        $d3:r.de.l:=r.de.l or $4; {set 2,E}
        $d4:r.hl.h:=r.hl.h or $4; {set 2,H}
        $d5:r.hl.l:=r.hl.l or $4; {set 2,L}
        $d6:begin  {set 2,(HL)}
                  temp:=ll.getbyte(r.hl.w) or 4;
                  ll.putbyte(r.hl.w,temp);
             end;
        $d7:r.a:=r.a or $4; {set 2,A}
        $d8:r.bc.h:=r.bc.h or $8; {set 3,B}
        $d9:r.bc.l:=r.bc.l or $8; {set 3,C}
        $da:r.de.h:=r.de.h or $8; {set 3,D}
        $db:r.de.l:=r.de.l or $8; {set 3,E}
        $dc:r.hl.h:=r.hl.h or $8; {set 3,H}
        $dd:r.hl.l:=r.hl.l or $8; {set 3,L}
        $de:begin  {set 3,(HL)}
                  temp:=ll.getbyte(r.hl.w) or 8;
                  ll.putbyte(r.hl.w,temp);
             end;
        $df:r.a:=r.a or $8; {set 3,A}
        $e0:r.bc.h:=r.bc.h or $10; {set 4,B}
        $e1:r.bc.l:=r.bc.l or $10; {set 4,C}
        $e2:r.de.h:=r.de.h or $10; {set 4,D}
        $e3:r.de.l:=r.de.l or $10; {set 4,E}
        $e4:r.hl.h:=r.hl.h or $10; {set 4,H}
        $e5:r.hl.l:=r.hl.l or $10; {set 4,L}
        $e6:begin  {set 4,(HL)}
                  temp:=ll.getbyte(r.hl.w) or $10;
                  ll.putbyte(r.hl.w,temp);
             end;
        $e7:r.a:=r.a or $10; {set 4,A}
        $e8:r.bc.h:=r.bc.h or $20; {set 5,B}
        $e9:r.bc.l:=r.bc.l or $20; {set 5,C}
        $ea:r.de.h:=r.de.h or $20; {set 5,D}
        $eb:r.de.l:=r.de.l or $20; {set 5,E}
        $ec:r.hl.h:=r.hl.h or $20; {set 5,H}
        $ed:r.hl.l:=r.hl.l or $20; {set 5,L}
        $ee:begin  {set 5,(HL)}
                  temp:=ll.getbyte(r.hl.w) or $20;
                  ll.putbyte(r.hl.w,temp);
             end;
        $ef:r.a:=r.a or $20; {set 5,A}
        $f0:r.bc.h:=r.bc.h or $40; {set 6,B}
        $f1:r.bc.l:=r.bc.l or $40; {set 6,C}
        $f2:r.de.h:=r.de.h or $40; {set 6,D}
        $f3:r.de.l:=r.de.l or $40; {set 6,E}
        $f4:r.hl.h:=r.hl.h or $40; {set 6,H}
        $f5:r.hl.l:=r.hl.l or $40; {set 6,L}
        $f6:begin  {set 6,(HL)}
                  temp:=ll.getbyte(r.hl.w) or $40;
                  ll.putbyte(r.hl.w,temp);
             end;
        $f7:r.a:=r.a or $40; {set 6,A}
        $f8:r.bc.h:=r.bc.h or $80; {set 7,B}
        $f9:r.bc.l:=r.bc.l or $80; {set 7,C}
        $fa:r.de.h:=r.de.h or $80; {set 7,D}
        $fb:r.de.l:=r.de.l or $80; {set 7,E}
        $fc:r.hl.h:=r.hl.h or $80; {set 7,H}
        $fd:r.hl.l:=r.hl.l or $80; {set 7,L}
        $fe:begin  {set 7,(HL)}
                  temp:=ll.getbyte(r.hl.w) or $80;
                  ll.putbyte(r.hl.w,temp);
             end;
        $ff:r.a:=r.a or $80; {set 7,A}
end;
exec_cb:=z80t_cb[instruccion];
end;

procedure bit_8(bit,valor:byte;reg:pband_z80);
begin
reg.h:=true;
reg.n:=false;
reg.s:=false;
reg.z:=not((valor and (1 shl bit))<>0);
reg.p_v:=reg.z;
reg.bit5:=(valor and $20)<>0;
reg.bit3:=(valor and 8)<>0;
end;

procedure bit7(valor:byte;reg:pband_z80);
begin
reg.z:=not((valor and $80)<>0);
reg.h:=true;
reg.n:=false;
reg.p_v:=reg.z;
reg.s:=(valor and $80)<>0;
reg.bit5:=(valor and $20)<>0;
reg.bit3:=(valor and 8)<>0;
end;

end.
