unit z80_dd_cb;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses z80,z80_cb;

const
z80t_ddcb:array[0..255] of byte=(
 //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
  23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,
20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,
20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,
20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23);

function exec_dd_cb(r:preg_z80;ll:llam_z80;tipo:boolean):byte;

implementation
function exec_dd_cb(r:preg_z80;ll:llam_z80;tipo:boolean):byte;
var
 instruccion,tempb:byte;
 temp2:word;
begin
if tipo then temp2:=r.ix.w else temp2:=r.iy.w;
//NO, NO y NO se considera un opcode
instruccion:=ll.getbyte(r.pc);
temp2:=temp2+shortint(instruccion);
instruccion:=ll.getbyte(r.pc+1);
r.pc:=r.pc+2;
case instruccion of
        $00:begin {ld B,rlc (IX+d) >23t<}
                r.bc.h:=ll.getbyte(temp2);
                rlc_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $01:begin {ld C,rlc (IX+d) >23t<}
                r.bc.l:=ll.getbyte(temp2);
                rlc_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $02:begin {ld D,rlc (IX+d) >23t<}
                r.de.h:=ll.getbyte(temp2);
                rlc_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $03:begin {ld E,rlc (IX+d) >23t<}
                r.de.l:=ll.getbyte(temp2);
                rlc_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $04:begin {ld H,rlc (IX+d) >23t<}
                r.hl.h:=ll.getbyte(temp2);
                rlc_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $05:begin {ld L,rlc (IX+d) >23t<}
                r.hl.l:=ll.getbyte(temp2);
                rlc_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $06:begin {rlc (IX+d) >23t<}
                tempb:=ll.getbyte(temp2);
                rlc_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $07:begin {ld A,rlc (IX+d) >23t<}
                r.a:=ll.getbyte(temp2);
                rlc_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $08:begin {ld B,rrc (IX+d) >23t<}
                r.bc.h:=ll.getbyte(temp2);
                rrc_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $09:begin {ld C,rrc (IX+d) >23t<}
                r.bc.l:=ll.getbyte(temp2);
                rrc_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $0a:begin {ld D,rrc (IX+d) >23t<}
                r.de.h:=ll.getbyte(temp2);
                rrc_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $0b:begin {ld E,rrc (IX+d) >23t<}
                r.de.l:=ll.getbyte(temp2);
                rrc_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $0c:begin {ld H,rrc (IX+d) >23t<}
                r.hl.h:=ll.getbyte(temp2);
                rrc_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $0d:begin {ld L,rlc (IX+d) >23t<}
                r.hl.l:=ll.getbyte(temp2);
                rrc_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $0e:begin   {rrc (IX+d)}
                tempb:=ll.getbyte(temp2);
                rrc_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $0f:begin {ld A,rrc (IX+d)}
                r.a:=ll.getbyte(temp2);
                rrc_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $10:begin {ld B,rl (IX+d)}
                r.bc.h:=ll.getbyte(temp2);
                rl_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $11:begin {ld C,rl (IX+d)}
                r.bc.l:=ll.getbyte(temp2);
                rl_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $12:begin {ld D,rl (IX+d)}
                r.de.h:=ll.getbyte(temp2);
                rl_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $13:begin {ld E,rl (IX+d)}
                r.de.l:=ll.getbyte(temp2);
                rl_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $14:begin {ld H,rl (IX+d)}
                r.hl.h:=ll.getbyte(temp2);
                rl_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $15:begin {ld L,rlc (IX+d)}
                r.hl.l:=ll.getbyte(temp2);
                rl_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $16:begin {rl (IX+d)}
                tempb:=ll.getbyte(temp2);
                rl_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $17:begin {ld A,rl (IX+d)}
                r.a:=ll.getbyte(temp2);
                rl_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $18:begin {ld B,rr (IX+d)}
                r.bc.h:=ll.getbyte(temp2);
                rr_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $19:begin {ld C,rr (IX+d)}
                r.bc.l:=ll.getbyte(temp2);
                rr_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $1a:begin {ld D,rr (IX+d)}
                r.de.h:=ll.getbyte(temp2);
                rr_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $1b:begin {ld E,rr (IX+d)}
                r.de.l:=ll.getbyte(temp2);
                rr_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $1c:begin {ld H,rr (IX+d)}
                r.hl.h:=ll.getbyte(temp2);
                rr_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $1d:begin {ld L,rr (IX+d)}
                r.hl.l:=ll.getbyte(temp2);
                rr_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $1e:begin  {rr (IX+d)}
                tempb:=ll.getbyte(temp2);
                rr_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $1f:begin {ld A,rr (IX+d)}
                r.a:=ll.getbyte(temp2);
                rr_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $20:begin {ld B,sla (IX+d)}
                r.bc.h:=ll.getbyte(temp2);
                sla_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $21:begin {ld C,sla (IX+d)}
                r.bc.l:=ll.getbyte(temp2);
                sla_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $22:begin {ld D,sla (IX+d)}
                r.de.h:=ll.getbyte(temp2);
                sla_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $23:begin {ld E,sla (IX+d)}
                r.de.l:=ll.getbyte(temp2);
                rlc_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $24:begin {ld H,sla (IX+d)}
                r.hl.h:=ll.getbyte(temp2);
                sla_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $25:begin {ld L,sla (IX+d)}
                r.hl.l:=ll.getbyte(temp2);
                sla_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $26:begin  {sla (IX+d)}
                tempb:=ll.getbyte(temp2);
                sla_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $27:begin {ld A,sla (IX+d)}
                r.a:=ll.getbyte(temp2);
                sla_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $28:begin {ld B,sra (IX+d)}
                r.bc.h:=ll.getbyte(temp2);
                sra_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $29:begin {ld C,sra (IX+d)}
                r.bc.l:=ll.getbyte(temp2);
                sra_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $2a:begin {ld D,sra (IX+d)}
                r.de.h:=ll.getbyte(temp2);
                sra_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $2b:begin {ld E,sra (IX+d)}
                r.de.l:=ll.getbyte(temp2);
                sra_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $2c:begin {ld H,sra (IX+d)}
                r.hl.h:=ll.getbyte(temp2);
                sra_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $2d:begin {ld L,sra (IX+d)}
                r.hl.l:=ll.getbyte(temp2);
                sra_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $2e:begin  {sra (IX+d)}
                tempb:=ll.getbyte(temp2);
                sra_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $2f:begin {ld A,sra (IX+d)}
                r.a:=ll.getbyte(temp2);
                sra_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $30:begin {ld B,sll (IX+d)}
                r.bc.h:=ll.getbyte(temp2);
                sll_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $31:begin {ld C,sll (IX+d)}
                r.bc.l:=ll.getbyte(temp2);
                sll_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $32:begin {ld D,sll (IX+d)}
                r.de.h:=ll.getbyte(temp2);
                sll_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $33:begin {ld E,sll (IX+d)}
                r.de.l:=ll.getbyte(temp2);
                sll_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $34:begin {ld H,sll (IX+d)}
                r.hl.h:=ll.getbyte(temp2);
                sll_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $35:begin {ld L,sll (IX+d)}
                r.hl.l:=ll.getbyte(temp2);
                sll_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $36:begin {sll (IX+d)}
                tempb:=ll.getbyte(temp2);
                sll_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $37:begin {ld A,sll (IX+d)}
                r.a:=ll.getbyte(temp2);
                sll_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $38:begin {ld B,srl (IX+d)}
                r.bc.h:=ll.getbyte(temp2);
                srl_8(r,@r.bc.h);
                ll.putbyte(temp2,r.bc.h);
            end;
        $39:begin {ld C,srl (IX+d)}
                r.bc.l:=ll.getbyte(temp2);
                srl_8(r,@r.bc.l);
                ll.putbyte(temp2,r.bc.l);
            end;
        $3a:begin {ld D,srl (IX+d)}
                r.de.h:=ll.getbyte(temp2);
                srl_8(r,@r.de.h);
                ll.putbyte(temp2,r.de.h);
            end;
        $3b:begin {ld E,srl (IX+d)}
                r.de.l:=ll.getbyte(temp2);
                srl_8(r,@r.de.l);
                ll.putbyte(temp2,r.de.l);
            end;
        $3c:begin {ld H,srl (IX+d)}
                r.hl.h:=ll.getbyte(temp2);
                srl_8(r,@r.hl.h);
                ll.putbyte(temp2,r.hl.h);
            end;
        $3d:begin {ld L,srl (IX+d)}
                r.hl.l:=ll.getbyte(temp2);
                srl_8(r,@r.hl.l);
                ll.putbyte(temp2,r.hl.l);
            end;
        $3e:begin  {srl (IX+d)}
                tempb:=ll.getbyte(temp2);
                srl_8(r,@tempb);
                ll.putbyte(temp2,tempb);
            end;
        $3f:begin {ld A,srl (IX+d)}
                r.a:=ll.getbyte(temp2);
                srl_8(r,@r.a);
                ll.putbyte(temp2,r.a);
            end;
        $40..$47:begin {bit 0,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(0,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $48..$4f:begin {bit 1,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(1,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $50..$57:begin {bit 2,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(2,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $58..$5f:begin {bit 3,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(3,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $60..$67:begin {bit 4,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(4,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $68..$6f:begin {bit 5,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(5,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $70..$77:begin {bit 6,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit_8(6,tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $78..$7f:begin {bit 7,(IX+d)}
                 tempb:=ll.getbyte(temp2);
                 bit7(tempb,@r.f);
                 r.f.bit5:=(temp2 and $2000)<>0;
                 r.f.bit3:=(temp2 and $800)<>0;
            end;
        $80:begin {ld B,res 0,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $81:begin {ld C,res 0,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $82:begin {ld D,res 0,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,r.de.h);
            end;
        $83:begin {ld E,res 0,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,r.de.l);
            end;
        $84:begin {ld H,res 0,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $85:begin {ld L,res 0,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $86:begin {res 0,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $fe;
                 ll.putbyte(temp2,tempb);
            end;
        $87:begin		// LD A,RES 0,(REGISTER+dd) */
                  r.a:=ll.getbyte(temp2) and $fe;
                  ll.putbyte(temp2,r.a);
            end;
        $88:begin		// LD B,RES 1,(REGISTER+dd) */
                  r.bc.h:=ll.getbyte(temp2) and $fd;
                  ll.putbyte(temp2,r.bc.h);
            end;
        $89:begin		// LD C,RES 1,(REGISTER+dd) */
                  r.bc.l:=ll.getbyte(temp2) and $fd;
                  ll.putbyte(temp2,r.bc.l);
            end;
        $8a:begin		// LD D,RES 1,(REGISTER+dd) */
                  r.de.h:=ll.getbyte(temp2) and $fd;
                  ll.putbyte(temp2,r.de.h);
            end;
        $8b:begin		// LD E,RES 1,(REGISTER+dd) */
                  r.de.l:=ll.getbyte(temp2) and $fd;
                  ll.putbyte(temp2,r.de.l);
            end;
        $8c:begin		// LD H,RES 1,(REGISTER+dd) */
                  r.hl.h:=ll.getbyte(temp2) and $fd;
                  ll.putbyte(temp2,r.hl.h);
            end;
        $8d:begin		// LD L,RES 1,(REGISTER+dd) */
                  r.hl.l:=ll.getbyte(temp2) and $fd;
                  ll.putbyte(temp2,r.hl.l);
            end;
        $8e:begin {res 1,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $fd;
                 ll.putbyte(temp2,tempb);
            end;
        $8f:begin {ld A,res 1,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $fd;
                 ll.putbyte(temp2,r.a);
            end;
        $90:begin {ld B,res 2,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $91:begin {ld C,res 2,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $92:begin {ld D,res 2,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.de.h);
            end;
        $93:begin {ld E,res 2,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.de.l);
            end;
        $94:begin {ld H,res 2,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $95:begin {ld L,res 2,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $96:begin {res 2,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,tempb);
            end;
        $97:begin {ld A,res 2,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $fb;
                 ll.putbyte(temp2,r.a);
            end;
        $98:begin {ld B,res 3,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $99:begin {ld C,res 3,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $9a:begin {ld D,res 3,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.de.h);
            end;
        $9b:begin {ld E,res 3,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.de.l);
            end;
        $9c:begin {ld H,res 3,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $9d:begin {ld L,res 3,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $9e:begin {res 3,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,tempb);
            end;
        $9f:begin {ld A,res 3,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $f7;
                 ll.putbyte(temp2,r.a);
            end;
        $a0:begin {ld B,res 4,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $a1:begin {ld C,res 4,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $a2:begin {ld D,res 4,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.de.h);
            end;
        $a3:begin {ld E,res 4,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.de.l);
            end;
        $a4:begin {ld H,res 4,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $a5:begin {ld L,res 4,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $a6:begin {res 4,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,tempb);
            end;
        $a7:begin {ld A,res 4,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $ef;
                 ll.putbyte(temp2,r.a);
            end;
        $a8:begin {ld B,res 5,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $a9:begin {ld C,res 5,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $aa:begin {ld D,res 5,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.de.h);
            end;
        $ab:begin {ld E,res 5,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.de.l);
            end;
        $ac:begin {ld H,res 5,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $ad:begin {ld L,res 5,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $ae:begin {res 5,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,tempb);
            end;
        $af:begin {ld A,res 5,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $df;
                 ll.putbyte(temp2,r.a);
            end;
        $b0:begin {ld B,res 6,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $b1:begin {ld C,res 6,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $b2:begin {ld D,res 6,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.de.h);
            end;
        $b3:begin {ld E,res 6,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.de.l);
            end;
        $b4:begin {ld H,res 6,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $b5:begin {ld L,res 6,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $b6:begin {res 6,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,tempb);
            end;
        $b7:begin {ld A,res 6,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $bf;
                 ll.putbyte(temp2,r.a);
            end;
        $b8:begin {ld B,res 7,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $b9:begin {ld C,res 7,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $ba:begin {ld D,res 7,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.de.h);
            end;
        $bb:begin {ld E,res 7,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.de.l);
            end;
        $bc:begin {ld H,res 7,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $bd:begin {ld L,res 7,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $be:begin {res 7,(IX+d)}
                 tempb:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,tempb);
            end;
        $bf:begin {ld A,res 7,(IX+d)}
                 r.a:=ll.getbyte(temp2) and $7f;
                 ll.putbyte(temp2,r.a);
            end;
        $c0:begin {ld B,set 0,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $c1:begin {ld C,set 0,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $c2:begin {ld D,set 0,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.de.h);
            end;
        $c3:begin {ld E,set 0,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.de.l);
            end;
        $c4:begin {ld H,set 0,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $c5:begin {ld L,set 0,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $c6:begin {set 0,(IX+d)}
                 tempb:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,tempb);
              end;
        $c7:begin {ld A,set 0,(IX+d)}
                 r.a:=ll.getbyte(temp2) or 1;
                 ll.putbyte(temp2,r.a);
            end;
        $c8:begin {ld B,set 1,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $c9:begin {ld C,set 1,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $ca:begin {ld D,set 1,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.de.h);
            end;
        $cb:begin {ld E,set 1,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.de.l);
            end;
        $cc:begin {ld H,set 1,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $cd:begin {ld L,set 1,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $ce:begin {set 1,(IX+d)}
                 tempb:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,tempb);
              end;

        $cf:begin {ld A,set 1,(IX+d)}
                 r.a:=ll.getbyte(temp2) or 2;
                 ll.putbyte(temp2,r.a);
            end;
        $d0:begin {ld B,set 2,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $d1:begin {ld C,set 2,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $d2:begin {ld D,set 2,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.de.h);
            end;
        $d3:begin {ld E,set 2,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.de.l);
            end;
        $d4:begin {ld H,set 2,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $d5:begin {ld L,set 2,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $d6:begin {set 2,(IX+d)}
                 tempb:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,tempb);
              end;
        $d7:begin {ld A,set 2,(IX+d)}
                 r.a:=ll.getbyte(temp2) or 4;
                 ll.putbyte(temp2,r.a);
            end;
        $d8:begin {ld B,set 3,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $d9:begin {ld C,set 3,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $da:begin {ld D,set 3,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.de.h);
            end;
        $db:begin {ld E,set 3,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.de.l);
            end;
        $dc:begin {ld H,set 3,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $dd:begin {ld L,set 3,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $de:begin {set 3,(IX+d)}
                 tempb:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,tempb);
              end;
        $df:begin {ld A,set 3,(IX+d)}
                 r.a:=ll.getbyte(temp2) or 8;
                 ll.putbyte(temp2,r.a);
            end;
        $e0:begin {ld B,set 4,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $e1:begin {ld C,set 4,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $e2:begin {ld D,set 4,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.de.h);
            end;
        $e3:begin {ld E,set 4,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.de.l);
            end;
        $e4:begin {ld H,set 4,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $e5:begin {ld L,set 4,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $e6:begin {set 4,(IX+d)}
                 tempb:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,tempb);
              end;
        $e7:begin {ld A,set 4,(IX+d)}
                 r.a:=ll.getbyte(temp2) or $10;
                 ll.putbyte(temp2,r.a);
            end;
        $e8:begin {ld B,set 5,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $e9:begin {ld C,set 5,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $ea:begin {ld D,set 5,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.de.h);
            end;
        $eb:begin {ld E,set 5,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.de.l);
            end;
        $ec:begin {ld H,set 5,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $ed:begin {ld L,set 5,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $ee:begin {set 5,(IX+d)}
                 tempb:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,tempb);
              end;
        $ef:begin {ld A,set 5,(IX+d)}
                 r.a:=ll.getbyte(temp2) or $20;
                 ll.putbyte(temp2,r.a);
            end;
        $f0:begin {ld B,set 6,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $f1:begin {ld C,set 6,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $f2:begin {ld D,set 6,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.de.h);
            end;
        $f3:begin {ld E,set 6,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.de.l);
            end;
        $f4:begin {ld H,set 6,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $f5:begin {ld L,set 6,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $f6:begin {set 6,(IX+d)}
                 tempb:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,tempb);
              end;
        $f7:begin {ld A,set 6,(IX+d)}
                 r.a:=ll.getbyte(temp2) or $40;
                 ll.putbyte(temp2,r.a);
            end;
        $f8:begin {ld B,set 7,(IX+d)}
                 r.bc.h:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.bc.h);
            end;
        $f9:begin {ld C,set 7,(IX+d)}
                 r.bc.l:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.bc.l);
            end;
        $fa:begin {ld D,set 7,(IX+d)}
                 r.de.h:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.de.h);
            end;
        $fb:begin {ld E,set 7,(IX+d)}
                 r.de.l:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.de.l);
            end;
        $fc:begin {ld H,set 7,(IX+d)}
                 r.hl.h:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.hl.h);
            end;
        $fd:begin {ld L,set 7,(IX+d)}
                 r.hl.l:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.hl.l);
            end;
        $fe:begin {set 7,(IX+d)}
                 tempb:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,tempb);
              end;
        $ff:begin {ld A,set 7,(IX+d)}
                 r.a:=ll.getbyte(temp2) or $80;
                 ll.putbyte(temp2,r.a);
            end;
end;
exec_dd_cb:=z80t_ddcb[instruccion];
end;

end.
