unit z80_dd_sp;

interface
uses z80,z80_sp,z80_dd_cb_sp,main_engine,spectrum_misc,principal;

procedure exec_dd_fd_sp(r:preg_z80;ll:llam_z80;tipo:boolean);

implementation
procedure exec_dd_fd_sp(r:preg_z80;ll:llam_z80;tipo:boolean);
var
 instruccion,temp:byte;
 temp2:word;
 registro:pparejas;
 posicion:parejas;
begin
if tipo then registro:=@r.ix else registro:=@r.iy;
temp2:=registro.w;
spec_retraso.retraso(r.pc);inc(r.contador,4);
instruccion:=ll.getbyte(r.pc);
inc(r.pc);
r.r:=((r.r+1) and $7f) or (r.r and $80);
case instruccion of
        $09:begin  {add IX,BC >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              add_16(r,registro,r.bc.w);
            end;
        $19:begin  {add IX,DE >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              add_16(r,registro,r.de.w);
            end;
        $21:begin {ld IX,nn >14t<}
                registro.l:=spec_getbyte(r.pc,r,ll);
                registro.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
            end;
        $22:begin {ld (nn),IX >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,registro.l,r,ll);
                spec_putbyte(posicion.w+1,registro.h,r,ll);
            end;
        $23:begin  {inc IX >10t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              inc(registro.w);
            end;
        $24:begin  {inc IXh >9t<}
                temp:=registro.h;
                inc_8(r,@temp);
                registro.h:=temp;
                inc(r.contador); 
            end;
        $25:begin {dec IXh >9t<}
                temp:=registro.h;
                dec_8(r,@temp);
                registro.h:=temp;
                inc(r.contador); 
            end;
        $26:begin  {ld IXh,n >11t<}
                registro.h:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $29:begin {add IX,IX >15t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                add_16(r,registro,registro.w);
            end;
        $2a:begin {ld (IX,(nn) >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                registro.l:=spec_getbyte(posicion.w,r,ll);
                registro.h:=spec_getbyte(posicion.w+1,r,ll);
            end;
        $2b:begin {dec IX >10t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                dec(registro.w);
            end;
        $2c:begin  {inc IXl >9t<}
                temp:=registro.l;
                inc_8(r,@temp);
                registro.l:=temp;
                inc(r.contador); 
            end;
        $2d:begin  {dec IXl >9t<}
                temp:=registro.l;
                dec_8(r,@temp);
                registro.l:=temp;
                inc(r.contador); 
            end;
        $2e:begin  {ld IXl,n >11t<}
                registro.l:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $34:begin {inc (IX+d) >23t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                spec_retraso.retraso(temp2);inc(r.contador); 
                inc_8(r,@temp);
                spec_putbyte(temp2,temp,r,ll);
            end;
        $35:begin {dec (IX+d) >23t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador);
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                spec_retraso.retraso(temp2);inc(r.contador); 
                dec_8(r,@temp);
                spec_putbyte(temp2,temp,r,ll);
           end;
        $36:begin {ld (IX+d),n >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                inc(r.pc);
                temp:=spec_getbyte(r.pc,r,ll);
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,temp,r,ll);
            end;
        $39:begin {add IX,SP >15t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                add_16(r,registro,r.sp);
            end;
        $44:begin  {ld B,IXh >9t<}
                r.bc.h:=registro^.h;
                inc(r.contador); 
            end;
        $45:begin  {ld B,IXl >9t<}
                r.bc.h:=registro^.l;
                inc(r.contador); 
            end;
        $46:begin {ld B,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                r.bc.h:=spec_getbyte(temp2,r,ll);
            end;
        $4c:begin  {ld C,IXh >9t<}
                r.bc.l:=registro^.h;
                inc(r.contador); 
            end;
        $4d:begin  {ld C,IXl >9t<}
                r.bc.l:=registro^.l;
                inc(r.contador); 
            end;
        $4e:begin {ld C,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                r.bc.l:=spec_getbyte(temp2,r,ll);
            end;
        $54:begin   {ld D,IXh >9t<}
                r.de.h:=registro^.h;
                inc(r.contador); 
            end;
        $55:begin   {ld D,IXl >9t<}
                r.de.h:=registro^.l;
                inc(r.contador); 
            end;
        $56:begin {ld D,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                r.de.h:=spec_getbyte(temp2,r,ll);
            end;
        $5c:begin {ld E,IXh >9t<}
                r.de.l:=registro^.h;
                inc(r.contador); 
            end;
        $5d:begin   {ld E,IXh >9t<}
                r.de.l:=registro^.l;
                inc(r.contador); 
            end;
        $5e:begin {ld E,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                r.de.l:=spec_getbyte(temp2,r,ll);
            end;
        $60:begin   {ld IXh,B >9t<}
              registro^.h:=r.bc.h;
              inc(r.contador); 
            end;
        $61:begin {ld IXh,C >9t<}
              registro^.h:=r.bc.l;
              inc(r.contador); 
            end;
        $62:begin   {ld IXh,D >9t<}
              registro^.h:=r.de.h;
              inc(r.contador); 
            end;
        $63:begin   {ld IXh,E >9t<}
              registro^.h:=r.de.l;
              inc(r.contador); 
            end;
        $64:inc(r.contador); {ld IXh,IXh >9t>}
        $65:begin   {ld IXh,IXl >9t<}
              registro^.h:=registro^.l;
              inc(r.contador);
            end;
        $66:begin {ld H,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                inc(r.pc);
                r.hl.h:=spec_getbyte(temp2,r,ll);
            end;
        $67:begin   {ld IXh,A >9t<}
              registro^.h:=r.a;
              inc(r.contador); 
            end;
        $68:begin   {ld IXl,B >9t<}
              registro^.l:=r.bc.h;
              inc(r.contador); 
            end;
        $69:begin   {ld IXl,C >9t<}
              registro^.l:=r.bc.l;
              inc(r.contador); 
            end;
        $6a:begin   {ld IXl,D >9t<}
              registro^.l:=r.de.h;
              inc(r.contador); 
            end;
        $6b:begin   {ld IXl,E >9t<}
              registro^.l:=r.de.l;
              inc(r.contador); 
            end;
        $6c:begin   {ld IXl,IXh >9t<}
              registro^.l:=registro^.h;
              inc(r.contador); 
            end;
        $6d:inc(r.contador); {ld IXl,IXl >9t<}
        $6e:begin {ld L,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                r.hl.l:=spec_getbyte(temp2,r,ll);
            end;
        $6f:begin  {ld IXl,A >9t<}
                registro^.l:=r.a;
                inc(r.contador); 
            end;
        $70:begin {ld (IX+d),B >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.bc.h,r,ll);
            end;
        $71:begin {ld (IX+d),C >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.bc.l,r,ll);
            end;
        $72:begin {ld (IX+d),D >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.de.h,r,ll);
            end;
        $73:begin {ld (IX+d),E >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.de.l,r,ll);
            end;
        $74:begin {ld (IX+d),H >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.hl.h,r,ll);
            end;
        $75:begin {ld (IX+d),L >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.hl.l,r,ll);
            end;
        $77:begin {ld (IX+d),A >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                spec_putbyte(temp2,r.a,r,ll);
            end;
        $7c:begin   {ld A,IXh >9t<}
                r.a:=registro^.h;
                inc(r.contador);
            end;
        $7d:begin {ld A,IXl >9t<}
                r.a:=registro^.l;
                inc(r.contador); 
            end;
        $7e:begin {ld A,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                r.a:=spec_getbyte(temp2,r,ll);
            end;
        $84:begin   {add A,IXh >9t<}
              add_8(r,registro.h);
              inc(r.contador); 
            end;
        $85:begin   {add A,IXl >9t<}
              add_8(r,registro.l);
              inc(r.contador); 
            end;
        $86:begin {add A,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador);
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                add_8(r,temp);
            end;
        $8c:begin   {adc A,IXh >9t<}
                adc_8(r,registro^.h);
                inc(r.contador); 
            end;
        $8d:begin   {adc A,IXl >9t<}
                adc_8(r,registro^.l);
                inc(r.contador); 
            end;
        $8e:begin {adc A,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                adc_8(r,temp);
        end;
        $94:begin  {sub IXh >9t<}
                sub_8(r,registro^.h);
                inc(r.contador); 
            end;
        $95:begin  {sub IXh >9t<}
                sub_8(r,registro^.l);
                inc(r.contador);
            end;
        $96:begin {sub (IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                sub_8(r,temp);
        end;
        $9c:begin  {sbc IXh >9t<}
                sbc_8(r,registro^.h);
                inc(r.contador); 
            end;
        $9d:begin  {sbc IXl >9t<}
                sbc_8(r,registro^.l);
                inc(r.contador); 
            end;
        $9e:begin {sbc (IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                sbc_8(r,temp);
        end;
        $a4:begin  {and IXh >9t<}
                and_a(r,registro^.h);
                inc(r.contador); 
            end;
        $a5:begin  {and IXl >9t<}
                and_a(r,registro^.l);
                inc(r.contador); 
            end;
        $a6:begin {and A,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                and_a(r,temp);
        end;
        $ac:begin  {xor IXh >9t<}
                xor_a(r,registro^.h);
                inc(r.contador); 
            end;
        $ad:begin  {xor IXl >9t<}
                xor_a(r,registro^.l);
                inc(r.contador); 
            end;
        $ae:begin {xor A,(IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                xor_a(r,temp);
              end;
        $b4:begin   {or IXh >9t<}
                or_a(r,registro^.h);
                inc(r.contador); 
            end;
        $b5:begin   {or IXl >9t<}
                or_a(r,registro^.l);
                inc(r.contador); 
            end;
        $b6:begin  {or (IX+d) >19t<}
                 temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                 spec_retraso.retraso(r.pc);inc(r.contador); 
                 spec_retraso.retraso(r.pc);inc(r.contador); 
                 spec_retraso.retraso(r.pc);inc(r.contador); 
                 spec_retraso.retraso(r.pc);inc(r.contador); 
                 spec_retraso.retraso(r.pc);inc(r.contador); 
                 inc(r.pc);
                 temp:=spec_getbyte(temp2,r,ll);
                 or_a(r,temp);
             end;
        $bc:begin  {cp IXh >9t<}
                cp_a(r,registro^.h);
                inc(r.contador); 
            end;
        $bd:begin  {cp IXl >9t<}
                cp_a(r,registro^.l);
                inc(r.contador); 
            end;
        $be:begin {cp (IX+d) >19t<}
                temp2:=temp2+shortint(spec_getbyte(r.pc,r,ll));
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                spec_retraso.retraso(r.pc);inc(r.contador); 
                inc(r.pc);
                temp:=spec_getbyte(temp2,r,ll);
                cp_a(r,temp);
        end;
        $cb:exec_dd_cb_sp(r,ll,tipo);
        $e1:begin
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                pop_sp(@r.sp,ll,registro);  {pop IX >14t<}
            end;
        $e3:begin   {ex (SP),IX >23t<}
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                pop_sp(@r.sp,ll,@posicion);
                spec_retraso.retraso(r.sp+1);inc(r.contador);
                push_sp(@r.sp,ll,registro);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp);inc(r.contador); 
                spec_retraso.retraso(r.sp);inc(r.contador); 
                registro.w:=posicion.w;
             end;
        $e5:begin  {push IX >15t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                push_sp(@r.sp,ll,registro);
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3);
            end;
        $e9:r.pc:=registro.w; {jp IX >8t<}
        $f9:begin {ld SP,IX >10t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              r.sp:=registro.w;
            end;
        else begin
          dec(r.pc);
          r.r:=(r.r-1) and $7f;
        end;
end;
end;

end.
