unit z80_ed_sp;

interface
uses z80,z80_sp,main_engine,spectrum_misc,z80_ed,principal,z80daisy;

procedure exec_ed_sp(r:preg_z80;ll:llam_z80);

implementation

procedure exec_ed_sp(r:preg_z80;ll:llam_z80);
var
        instruccion,temp,temp2,temp3:byte;
        tempw:word;
        posicion:parejas;
begin
spec_retraso.retraso(r.pc);inc(r.contador,4);
instruccion:=ll.getbyte(r.pc);
inc(r.pc);
r.r:=((r.r+1) and $7f) or (r.r and $80);
case instruccion of
        $40:begin {in B,(c) >12t<}
                r.bc.h:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.bc.h=0);
                r.f.s:=(r.bc.h And $80)<>0;
                r.f.bit3:=(r.bc.h And 8)<>0;
                r.f.bit5:=(r.bc.h And $20)<>0;
                r.f.p_v:=paridad[r.bc.h];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $41:spec_outbyte(r.bc.h,r.bc.w,r,ll); {out (C),B >12t<}
        $42:begin  {sbc HL,BC >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              sbc_16(@r.f,@r.hl,r.bc.w);
            end;
        $43:begin {ld (nn),BC >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,r.bc.l,r,ll);
                spec_putbyte(posicion.w+1,r.bc.h,r,ll);
            end;
        $44,$4c,$54,$5c,$64,$6c,$74,$7c:begin  {neg >8t<}
                temp:=r.a;
                r.a:=0;
                sub_8(r,temp);
            end;
        $45,$55,$65,$75:begin  {retn >8t<}
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                pop_sp(@r.sp,ll,@r.pc);
                r.iff1:=r.iff2;
            end;
        $46,$4e,$66,$6e:r.im:=0; {im 0 >8t<}
        $47:begin   {ld I,A >9t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              r.i:=r.a;
            end;
        $48:begin {in C,(C) >12t<}
                r.bc.l:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.bc.l=0);
                r.f.s:=(r.bc.l And $80) <> 0;
                r.f.bit3:=(r.bc.l And 8) <> 0;
                r.f.bit5:=(r.bc.l And $20) <> 0;
                r.f.p_v:=paridad[r.bc.l];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $49:spec_outbyte(r.bc.l,r.bc.w,r,ll); {out (C),C >12t<}
        $4a:begin  {adc HL,BC >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              adc_16(@r.f,@r.hl, r.bc.w);
            end;
        $4b:begin  {ld BC,(nn) >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                r.bc.l:=spec_getbyte(posicion.w,r,ll);
                r.bc.h:=spec_getbyte(posicion.w+1,r,ll);
            end;
        //4c: neg
        $4d,$5d,$6d,$7d:begin   {reti}
                r.iff1:=r.iff2;
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                pop_sp(@r.sp,ll,@r.pc);
                if r.daisy then z80daisy_reti;
            end;
        //4e: im 0
        $4f:begin  {ld R,A >9t<}
              r.r:=r.a;
              inc(r.contador);
            end;
        $50:begin {in D,(c) >12t<}
                r.de.h:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.de.h=0);
                r.f.s:=(r.de.h And $80) <> 0;
                r.f.bit3:=(r.de.h And 8) <> 0;
                r.f.bit5:=(r.de.h And $20) <> 0;
                r.f.p_v:=paridad[r.de.h];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $51:spec_outbyte(r.de.h,r.bc.w,r,ll); {out (C),D >12t<}
        $52:begin
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              sbc_16(@r.f,@r.hl,r.de.w); {sbc HL,DE >15t<}
            end;
        $53:begin {ld (nn),DE >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,r.de.l,r,ll);
                spec_putbyte(posicion.w+1,r.de.h,r,ll);
            end;
        {54: neg
        $55:retn}
        $56,$76:r.im:=1; {im 1 >8t<}
        $57:begin  {ld A,I >9t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                r.a:=r.i;
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.h:=false;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.p_v:=r.iff2;
                r.f.n:=false;
            end;
        $58:begin  {in E,(C) >12t<}
                r.de.l:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.de.l=0);
                r.f.s:=(r.de.l And $80) <> 0;
                r.f.bit3:=(r.de.l And 8) <> 0;
                r.f.bit5:=(r.de.l And $20) <> 0;
                r.f.p_v:=paridad[r.de.l];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $59:spec_outbyte(r.de.l,r.bc.w,r,ll); {out (C),E >12t<}
        $5a:begin {adc HL,DE >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              adc_16(@r.f,@r.hl,r.de.w);
            end;
        $5b:begin  {ld DE,(nn) >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                r.de.l:=spec_getbyte(posicion.w,r,ll);
                r.de.h:=spec_getbyte(posicion.w+1,r,ll);
            end;
        {5c:neg
        5d:retn}
        $5e,$7e:r.im:=2; {im 2 >8t<}
        $5f:begin  {ld A,R >9t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                r.a:=r.r;
                r.f.h:=false;
                r.f.n:=false;
                r.f.p_v:=r.iff2;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
            end;
        $60:begin  {in H,(c) >12t<}
                r.hl.h:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.hl.h=0);
                r.f.s:=(r.hl.h And $80) <> 0;
                r.f.bit3:=(r.hl.h And 8) <> 0;
                r.f.bit5:=(r.hl.h And $20) <> 0;
                r.f.p_v:=paridad[r.hl.h];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $61:spec_outbyte(r.hl.h,r.bc.w,r,ll); {out (C),H >12t<}
        $62:begin  {sbc HL,HL >20t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                sbc_16(@r.f,@r.hl,r.hl.w);
            end;
        $63:begin {ld (nn),HL >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,r.hl.l,r,ll);
                spec_putbyte(posicion.w+1,r.hl.h,r,ll);
            end;
        {64:neg
        $65:retn
        $66:im 0}
        $67:begin {rrd >18t<}
                temp2:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                temp:=(r.a and $F)*16;
                r.a:=(r.a and $F0)+ (temp2 and $F);
                temp2:=(temp2 div 16) + temp;
                spec_putbyte(r.hl.w,temp2,r,ll);
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.h:=false;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.p_v:=paridad[r.a];
                r.f.n:=false;
            end;
        $68:begin {in L,(c) >12t<}
                r.hl.l:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.hl.l=0);
                r.f.s:=(r.hl.l And $80) <> 0;
                r.f.bit3:=(r.hl.l And 8) <> 0;
                r.f.bit5:=(r.hl.l And $20) <> 0;
                r.f.p_v:=paridad[r.hl.l];
                r.f.n:=false;
                r.f.h:=false;
             end;
        $69:spec_outbyte(r.hl.l,r.bc.w,r,ll); {out (C),L >12t<}
        $6a:begin  {adc HL,HL >15t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                adc_16(@r.f,@r.hl,r.hl.w);
            end;
        $6b:begin  {ld HL,(nn) >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                r.hl.l:=spec_getbyte(posicion.w,r,ll);
                r.hl.h:=spec_getbyte(posicion.w+1,r,ll);
            end;
        {6c:neg
        $6d:retn
        $6e:im 0}
        $6f:begin  {rld >18t<}
                temp2:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                temp:=r.a and $0f;
                r.a:=(r.a  and $F0)+ (temp2 div 16);
                temp2:=(temp2*16) + temp;
                spec_putbyte(r.hl.w,temp2,r,ll);
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.h:=false;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.p_v:=paridad[r.a];
                r.f.n:=false;
            end;
        $70:begin  {in (C) >12t<}
                temp:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(temp=0);
                r.f.s:=(temp And $80) <> 0;
                r.f.bit3:=(temp And 8) <> 0;
                r.f.bit5:=(temp And $20) <> 0;
                r.f.p_v:=paridad[temp];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $71:spec_outbyte(0,r.bc.w,r,ll); {out (C),0 >12t<}
        $72:begin  {sbc HL,SP >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              sbc_16(@r.f,@r.hl,r.sp);
            end;
        $73:begin {ld (nn),SP >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,r.sp and $ff,r,ll);
                spec_putbyte(posicion.w+1,r.sp shr 8,r,ll);
            end;
        {74:neg
        $75:retn
        $76:im 1
        $77:nop*2}
        $78:begin       {in A,(C) >12t<}
                r.a:=spec_inbyte(r.bc.w,r,ll);
                r.f.z:=(r.a=0);
                r.f.s:=(r.a and $80)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.p_v:=paridad[r.a];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $79:spec_outbyte(r.a,r.bc.w,r,ll); {out (C),A >12t<}
        $7a:begin  {adc HL,SP >15t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              adc_16(@r.f,@r.hl,r.sp);
            end;
        $7b:begin  {ld SP,(nn) >20t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                r.sp:=spec_getbyte(posicion.w,r,ll)+(spec_getbyte(posicion.w+1,r,ll) shl 8);
            end;
        {7c:neg
        $7d:retn
        $7e:im 2
        $7f..9c:nop*2}
        $a0:begin   {ldi >16t<}
                 temp:=spec_getbyte(r.hl.w,r,ll);
                 dec(r.bc.w);
                 spec_putbyte(r.de.w,temp,r,ll);
                 spec_retraso.retraso(r.de.w);inc(r.contador);
                 spec_retraso.retraso(r.de.w);inc(r.contador);
                 inc(r.de.w);
                 inc(r.hl.w);
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=false;
                 r.f.h:=false;
                 temp:=temp+r.a;
                 r.f.bit5:=(temp and 2)<>0;
                 r.f.bit3:=(temp and 8)<>0;
            end;
        $a1:begin  //cpi el primer programa que lo usa una demo!!!
                 //08 de feb 2003 >16t<
                 temp2:=spec_getbyte(r.hl.w,r,ll);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 inc(r.hl.w);
                 dec(r.bc.w);
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.bit5:=((temp-((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp-((temp3 shr 4) and 1)) and 8)<>0;
             end;
        $a2:begin  //ini
                   //Primer juego que lo usa Titan 09 de Sep 2006
                 spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                 temp:=spec_inbyte(r.bc.w,r,ll);
                 spec_putbyte(r.hl.w,temp,r,ll);
                 dec(r.bc.h);
                 inc(r.hl.w);
                 r.f.n:=(temp and $80)<>0;
                 tempw:=temp+r.bc.l+1;
                 r.f.h:=(tempw and $100)<>0;
                 r.f.c:=(tempw and $100)<>0;
                 r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                 r.f.z:=(r.bc.h=0);
                 r.f.bit5:=(r.bc.h and $20)<>0;
                 r.f.bit3:=(r.bc.h and 8)<>0;
                 r.f.s:=(r.bc.h and $80)<>0;
            end;
        $a3:begin //outi el primer programa que lo usa una demo!!!
                 //08 de feb 2003 >16t<
                 spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                 temp:=spec_getbyte(r.hl.w,r,ll);
                 dec(r.bc.h);
                 spec_outbyte(temp,r.bc.w,r,ll);
                 inc(r.hl.w);
                 r.f.n:=(temp and $80)<>0;
                 tempw:=temp+r.hl.l;
                 r.f.h:=(tempw and $100)<>0;
                 r.f.c:=(tempw and $100)<>0;
                 r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                 r.f.z:=(r.bc.h=0);
                 r.f.bit5:=(r.bc.h and $20)<>0;
                 r.f.bit3:=(r.bc.h and 8)<>0;
                 r.f.s:=(r.bc.h and $80)<>0;
             end;
        // $a4..$a7:nop*2
        $a8:begin  {ldd >16t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                dec(r.bc.w);
                spec_putbyte(r.de.w,temp,r,ll);
                spec_retraso.retraso(r.de.w);inc(r.contador);
                spec_retraso.retraso(r.de.w);inc(r.contador);
                dec(r.de.w);
                dec(r.hl.w);
                r.f.p_v:=(r.bc.w<>0);
                temp:=temp+r.a;
                r.f.bit5:=(temp and 2)<>0;
                r.f.bit3:=(temp and 8)<>0;
                r.f.n:=false;
                r.f.h:=false;
            end;
        $a9:begin //cpd el primer juego que la usa Ace 2
                 //20-09-04 >16t<
                 temp2:=spec_getbyte(r.hl.w,r,ll);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 dec(r.hl.w);
                 r.bc.w:=r.bc.w-1;
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.bit5:=((temp-((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp-((temp3 shr 4) and 1)) and 8)<>0;
           end;
        $aa:begin  //ind  >16t<
                 spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                 temp:=spec_inbyte(r.bc.w,r,ll);
                 spec_putbyte(r.hl.w,temp,r,ll);
                 r.bc.h:=r.bc.h-1;
                 r.hl.w:=r.hl.w-1;
                 r.f.n:=(temp and $80)<>0;
                 tempw:=temp+r.bc.l-1;
                 r.f.h:=(tempw and $100)<>0;
                 r.f.c:=(tempw and $100)<>0;
                 r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                 r.f.z:=(r.bc.h=0);
                 r.f.bit5:=(r.bc.h and $20)<>0;
                 r.f.bit3:=(r.bc.h and 8)<>0;
                 r.f.s:=(r.bc.h and $80)<>0;
            end;
        $ab:begin   {outd >16t<}
                 spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                 temp:=spec_getbyte(r.hl.w,r,ll);
                 dec(r.bc.h);
                 spec_outbyte(temp,r.bc.w,r,ll);
                 dec(r.hl.w);
                 r.f.n:=(temp and $80)<>0;
                 tempw:=temp+r.hl.l;
                 r.f.h:=(tempw and $100)<>0;
                 r.f.c:=(tempw and $100)<>0;
                 r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                 r.f.z:=(r.bc.h=0);
                 r.f.bit5:=(r.bc.h and $20)<>0;
                 r.f.bit3:=(r.bc.h and 8)<>0;
                 r.f.s:=(r.bc.h and $80)<>0;
            end;
        {ac..$af:nop*2}
        $b0:begin {ldir >16t o 21t<}
                 temp:=spec_getbyte(r.hl.w,r,ll);
                 spec_putbyte(r.de.w,temp,r,ll);
                 spec_retraso.retraso(r.de.w);inc(r.contador);
                 spec_retraso.retraso(r.de.w);inc(r.contador);
                 dec(r.bc.w);
                 if (r.bc.w<>0) then begin
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        dec(r.pc,2);
                 end;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=false;
                 r.f.h:=false;
                 temp:=temp+r.a;
                 r.f.bit5:=(temp and 2)<>0;
                 r.f.bit3:=(temp and 8)<>0;
                 inc(r.hl.w);
                 inc(r.de.w);
             end;
        $b1:begin  {cpir >16t o 21t<}
                 temp2:=spec_getbyte(r.hl.w,r,ll);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 dec(r.bc.w);
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.bit5:=((temp-((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp-((temp3 shr 4) and 1)) and 8)<>0;
                 If (r.f.p_v And not(r.f.z)) then begin
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        dec(r.pc,2);
                 end;
                 inc(r.hl.w);
            end;
        $b2:begin		// inir
                 spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                 temp:=spec_inbyte(r.bc.w,r,ll);
                 spec_putbyte(r.hl.w,temp,r,ll);
                 dec(r.bc.h);
                 r.f.n:=(temp and $80)<>0;
                 tempw:=temp+r.bc.l+1;
                 r.f.h:=(tempw and $100)<>0;
                 r.f.c:=(tempw and $100)<>0;
                 r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                 r.f.z:=(r.bc.h=0);
                 r.f.bit5:=(r.bc.h and $20)<>0;
                 r.f.bit3:=(r.bc.h and 8)<>0;
                 r.f.s:=(r.bc.h and $80)<>0;
                 if r.bc.h<>0 then begin
                  spec_retraso.retraso(r.hl.w);inc(r.contador);
                  spec_retraso.retraso(r.hl.w);inc(r.contador);
                  spec_retraso.retraso(r.hl.w);inc(r.contador);
                  spec_retraso.retraso(r.hl.w);inc(r.contador);
                  spec_retraso.retraso(r.hl.w);inc(r.contador);
                  dec(r.pc,2);
                end;
                inc(r.hl.w);
        end;
        $b3:begin //otir aadido el dia 18-09-04 >16t o 21t<
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                temp:=spec_getbyte(r.hl.w,r,ll);
                dec(r.bc.h);
                spec_outbyte(temp,r.bc.w,r,ll);
                inc(r.hl.w);
                r.f.n:=(temp and $80)<>0;
                tempw:=temp+r.hl.l;
                r.f.h:=(tempw and $100)<>0;
                r.f.c:=(tempw and $100)<>0;
                r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                r.f.z:=(r.bc.h=0);
                r.f.bit5:=(r.bc.h and $20)<>0;
                r.f.bit3:=(r.bc.h and 8)<>0;
                r.f.z:=(r.bc.h and $80)<>0;
                if r.bc.h<>0 then begin
                  spec_retraso.retraso(r.bc.w);inc(r.contador);
                  spec_retraso.retraso(r.bc.w);inc(r.contador);
                  spec_retraso.retraso(r.bc.w);inc(r.contador);
                  spec_retraso.retraso(r.bc.w);inc(r.contador);
                  spec_retraso.retraso(r.bc.w);inc(r.contador);
                  dec(r.pc,2);
                end;
            end;
        { $b4..$b7:nop*2}
        $b8:begin {lddr >16t o 21t<}
                 temp:=spec_getbyte(r.hl.w,r,ll);
                 spec_putbyte(r.de.w,temp,r,ll);
                 spec_retraso.retraso(r.de.w);inc(r.contador);
                 spec_retraso.retraso(r.de.w);inc(r.contador);
                 dec(r.bc.w);
                 if (r.bc.w<>0) then begin
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        spec_retraso.retraso(r.de.w);inc(r.contador);
                        dec(r.pc,2);
                 end;
                 r.f.p_v:=(r.bc.w<>0);
                 temp:=temp+r.a;
                 r.f.bit5:=(temp and 2)<>0;
                 r.f.bit3:=(temp and 8)<>0;
                 r.f.n:=false;
                 r.f.h:=false;
                 dec(r.hl.w);
                 dec(r.de.w);
             end;
        $b9:begin   {cpdr >16t o 21t<}
                 temp2:=spec_getbyte(r.hl.w,r,ll);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 spec_retraso.retraso(r.hl.w);inc(r.contador);
                 dec(r.bc.w);
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.bit5:=((temp-((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp-((temp3 shr 4) and 1)) and 8)<>0;
                 if r.f.p_v and not(r.f.z) then begin
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        dec(r.pc,2);
                 end;
                 r.hl.w:=r.hl.w-1;
             end;
        $ba:begin  //indr  >16t<
                 spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                 temp:=spec_inbyte(r.bc.w,r,ll);
                 spec_putbyte(r.hl.w,temp,r,ll);
                 r.bc.h:=r.bc.h-1;
                 r.f.n:=(temp and $80)<>0;
                 tempw:=temp+r.bc.l-1;
                 r.f.h:=(tempw and $100)<>0;
                 r.f.c:=(tempw and $100)<>0;
                 r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                 r.f.z:=(r.bc.h=0);
                 r.f.bit5:=(r.bc.h and $20)<>0;
                 r.f.bit3:=(r.bc.h and 8)<>0;
                 r.f.s:=(r.bc.h and $80)<>0;
                 if (r.bc.h<>0) then begin
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        spec_retraso.retraso(r.hl.w);inc(r.contador);
                        dec(r.pc,2);
                 end;
                 r.hl.w:=r.hl.w-1;
            end;
        $bb:begin //otdr
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                temp:=spec_getbyte(r.hl.w,r,ll);
                dec(r.bc.h);
                spec_outbyte(temp,r.bc.w,r,ll);
                dec(r.hl.w);
                r.f.n:=(temp and $80)<>0;
                tempw:=temp+r.hl.l;
                r.f.h:=(tempw and $100)<>0;
                r.f.c:=(tempw and $100)<>0;
                r.f.p_v:=paridad[(tempw and $7) xor r.bc.h];
                r.f.z:=(r.bc.h=0);
                r.f.bit5:=(r.bc.h and $20)<>0;
                r.f.bit3:=(r.bc.h and 8)<>0;
                r.f.s:=(r.bc.h and $80)<>0;
                if (r.bc.h<>0) then begin
                    spec_retraso.retraso(r.bc.w);inc(r.contador);
                    spec_retraso.retraso(r.bc.w);inc(r.contador);
                    spec_retraso.retraso(r.bc.w);inc(r.contador);
                    spec_retraso.retraso(r.bc.w);inc(r.contador);
                    spec_retraso.retraso(r.bc.w);inc(r.contador);
                    dec(r.pc,2);
                end;
            end;
        $fb:main_vars.mensaje_general:='Instruccion no implmentada EDFB';
end;
end;

end.
